# BMP280 sensor API

> This package contains BMP280 sensor API

## Sensor Overview
BMP280 is an absolute barometric pressure sensor especially designed for mobile applications.The sensor module is housed in an extremely compact package. Its small dimensions and its low power consumption allow for the implementation in battery powered devices such as mobile phones, GPS modules or watches. BMP280 is based on Bosch's proven Piezo-resistive pressure sensor technology featuring high accuracy and linearity as well as long term stability and high EMC robustness.

## Key features
* Operation range (full accuracy) : Pressure: 300...1100 hPa.  Temperature: -40 .... +85 degrees C .

* Absolute accuracy(Temp. @ 0 ..... +65 degrees C)  : ~ +/- 1 hPa </br>	
  
* Relative accuracy (p = 700…900hPa, Temp. @ +25 .... +40 degrees C): +/-0.12 hPa (typical) equivalent to ±1 m.
  									
* Average current consumption (1 Hz data refresh rate) :   2.74 μA, typical (ultra-low power mode).
 
* Average current consumption in sleep mode :   0.1 μA.

* Average measurement time :   5.5 msec (ultra-low power preset).
  
* Supply voltage VDDIO :  1.2 ... 3.6 V.

* Supply voltage VDD : 1.71 ... 3.6 V.
  
* Resolution of data : Pressure: 0.01 hPa ( < 10 cm).  Temperature: 0.01 degree C.
 
* Temperature coefficient offset (+25°…+40°C @900hPa) :  ± 0.12 hPa (typical)   equivalent to ±1 m
 
* Interface :  I²C and SPI

* Package dimensions :   8-Pin LGA with metal.   2.0 x 2.5 x 0.95 mm³

For more information refer product page [Link](https://www.bosch-sensortec.com/bst/products/all_products/bmp280)

---
#### Copyright (C) 2018 Bosch Sensortec GmbH