#include "rtx_os.h"

#include "tm_stm32f4_disco.h"
#include "tm_stm32f4_i2c.h"
#include "defines.h"
#include "arm_math.h"

void delay_ms(uint32_t period_ms)
{
	osDelay(period_ms);
}

int8_t i2c_reg_write(uint8_t i2c_addr, uint8_t reg_addr, uint8_t *reg_data, uint16_t length)	//Zapise blok byte s registrom
{
	TM_I2C_WriteMulti(I2C1,i2c_addr,reg_addr,reg_data,length);
	return 0;
}

int8_t i2c_reg_read(uint8_t i2c_addr, uint8_t reg_addr, uint8_t *reg_data, uint16_t length)		//Precita blok byte s registrom
{
  TM_I2C_ReadMulti(I2C1,i2c_addr,reg_addr,reg_data,length);
	return 0;
}

int8_t i2c_reg_write_no_register(uint8_t i2c_addr, uint8_t *reg_data, uint16_t length)				//Zapise blok byte bez registra
{
	TM_I2C_WriteMultiNoRegister(I2C1,i2c_addr,reg_data,length);
	return 0;
}

int8_t i2c_reg_read_no_register(uint8_t i2c_addr, uint8_t *reg_data, uint16_t length)					//Precita blok byte bez registra
{
  TM_I2C_ReadMultiNoRegister(I2C1,i2c_addr,reg_data,length);
	return 0;
}

int8_t i2c_read_no_register(uint8_t i2c_addr)																									//Precita 1 byte bez registra
{
	return TM_I2C_ReadNoRegister(I2C1,i2c_addr);
	//return 0;
}

int8_t i2c_read(uint8_t i2c_addr,uint8_t reg)																									//Precita 1 byte s registrom registra
{
 return TM_I2C_Read(I2C1,i2c_addr,reg);
}


int8_t i2c_write_no_register(uint8_t i2c_address, uint8_t data)																//Zapise 1 byte bez registra
{
	TM_I2C_WriteNoRegister(I2C1,i2c_address,data);
	return 0;
}

int8_t i2c_write(uint8_t i2c_addr, uint8_t reg, uint8_t data)																	//Zapise 1 byte s registrom
{
	TM_I2C_Write(I2C1,i2c_addr,reg,data);
	return 0;
}

/*
int8_t i2c_reg_write(uint8_t i2c_addr, uint8_t reg_addr, uint8_t *reg_data, uint16_t length)	//Zapise blok byte s registrom
{
	TM_I2C_WriteMulti(I2C1,i2c_addr,reg_addr,reg_data,length);
	return 0;
}

int8_t i2c_reg_read(uint8_t i2c_addr, uint8_t reg_addr, uint8_t *reg_data, uint16_t length)		//Precita blok byte s registrom
{
  TM_I2C_ReadMulti(I2C1,i2c_addr,reg_addr,reg_data,length);
	return 0;
}

int8_t i2c_reg_write_no_register(uint8_t i2c_addr, uint8_t *reg_data, uint16_t length)				//Zapise blok byte bez registra
{
	TM_I2C_WriteMultiNoRegister(I2C1,i2c_addr,reg_data,length);
	return 0;
}

int8_t i2c_reg_read_no_register(uint8_t i2c_addr, uint8_t *reg_data, uint16_t length)					//Precita blok byte bez registra
{
  TM_I2C_ReadMultiNoRegister(I2C1,i2c_addr,reg_data,length);
	return 0;
}

int8_t i2c_read_no_register(uint8_t i2c_addr, uint8_t reg_data)																//Precita 1 byte bez registra
{
	TM_I2C_ReadNoRegister(I2C1,reg_data);
	return 0;
}

int8_t i2c_write_no_register(uint8_t i2c_address, uint8_t data)																//Zapise 1 byte bez registra
{
	TM_I2C_WriteNoRegister(I2C1,i2c_address,data);
	return 0;
}
*/
