#include "cmsis_os2.h"
#include "rtx_os.h"
#include "defines.h"


#define	Riadok1 0x80+0x00
#define	Riadok2 0x80+0x40
#define	Riadok3 0x80+0x14
#define	Riadok4 0x80+0x54
#define	WRITE		0x00
#define	READ		0x01

/* Slave address 0x4E = 0x40+0x08+0x04+0x02 */
#define ADDRESS_PCF8574A	(0x27<<1)								//left aligned 7-bit address
//#define ADDRESS_PCF8574A	0x4E									//left aligned 7-bit address
//#define Offset 						0x08									//Musi tu byt aby nepreblikavalo podsvietenie, ale preco to veru neviem ...

#define	LCD_ROWS			(uint8_t)4
#define	LCD_COLUMNS		(uint8_t)(20+1+0)						//Potrebujem viac priestoru pre ukoncovacie znaky ak pouzijem strcpy(), pri memcpy() staci 20 Byte !!!

#define VOLATILEx

#ifdef VOLATILE

typedef struct lcd_command_and_data
{
 uint8_t data[4];
}
volatile lcd_status_t;

typedef struct
{
 uint8_t Lcd_Line[LCD_COLUMNS];										//Nastavim pocet stlpcov LCD_COLUMNS
}
volatile Lcd_Line_Buffer;

typedef struct
{
 Lcd_Line_Buffer LCD;
}
volatile LCD_Buffer_t;

#else

typedef struct lcd_command_and_data
{
 uint8_t data[4];
}
lcd_status_t;

typedef struct
{
 uint8_t Lcd_Line[LCD_COLUMNS];										//Nastavim pocet stlpcov LCD_COLUMNS
}
Lcd_Line_Buffer;

typedef struct
{
 Lcd_Line_Buffer LCD;
}
LCD_Buffer_t;

#endif

void lcd_init(uint8_t lcd_backlight);							// initialize lcd
void lcd_send_statement(uint8_t, uint8_t);				// send command and data to the lcd
//void lcd_send_cmd(uint8_t cmd);										// send command to the lcd
//void lcd_send_data(uint8_t data);									// send data to the lcd
void lcd_send_string(uint8_t *str);							// send string to the lcd
void Lcd_Refresh_Display(uint8_t Line, uint8_t *str, uint8_t lcd_backlight);	// send string to the lcd

extern int8_t i2c_reg_write(uint8_t i2c_addr,uint8_t reg_addr,uint8_t *reg_data,uint16_t length);			//Zapis bloku na I2C s registrom !
extern int8_t i2c_reg_read(uint8_t i2c_addr,uint8_t reg_addr,uint8_t *reg_data,uint16_t length);			//Citanie bloku na I2C s registrom !
extern int8_t i2c_reg_write_no_register(uint8_t i2c_addr,uint8_t *reg_data,uint16_t length);					//Zapis blok na I2C bez registra ...
extern int8_t i2c_reg_read_no_register(uint8_t i2c_addr, uint8_t *reg_data, uint16_t length);					//Precita blok byte bez registra
extern int8_t i2c_write_no_register(uint8_t i2c_address, uint8_t data);																//Zapise 1 byte bez registra
extern int8_t i2c_read_no_register(uint8_t i2c_addr);																									//Precita 1 byte bez registra
extern int8_t i2c_write(uint8_t i2c_addr, uint8_t reg, uint8_t data);																	//Zapise 1 byte s registrom
extern int8_t i2c_read(uint8_t,uint8_t);																															//Precita 1 byte s registrom

/*
int8_t i2c_read_no_register(uint8_t i2c_addr);		//Citanie na I2C bez registra

int8_t i2c_read(uint8_t i2c_addr,uint8_t reg_data);																					//Citaj na I2C s registrom !

int8_t i2c_read_no_register(uint8_t i2c_addr);																							//Precita 1 byte bez registra

int8_t i2c_write_no_register(uint8_t i2c_address,uint8_t data);															//Zapis na I2C bez registra !
*/
