/*----------------------------------------------------------------------------
 * CMSIS-RTOS 'main' function template
 *---------------------------------------------------------------------------*/

#include "RTE_Components.h"
#include  CMSIS_device_header
#include "cmsis_os2.h"
#include "rtx_config.h"
#include "rtx_os.h"

#ifdef RTE_Compiler_EventRecorder
#include "EventRecorder.h"
#endif

#include "tm_stm32f4_delay.h"
#include "tm_stm32f4_disco.h"
#include "tm_stm32f4_adc.h"
#include "tm_stm32f4_dac.h"
#include "tm_stm32f4_rtc.h"
#include "tm_stm32f4_i2c.h"
#include "tm_stm32f4_spi.h"
#include "tm_stm32f4_usart.h"
#include "tm_stm32f4_stdio.h"
#include "tm_stm32f4_nrf24l01.h"
#include "tm_stm32f4_ssd1306.h"
#include "tm_stm32f4_bmp180.h"
#include "tm_stm32f4_onewire.h"
#include "tm_stm32f4_ds18b20.h"
#include "tm_stm32f4_ds1307.h"
#include "tm_stm32f4_i2c.h"
#include "tm_stm32f4_fatfs.h"
#include "tm_stm32f4_bkpsram.h"
#include "tm_stm32f4_rotary_encoder.h"
#include "tm_stm32f4_pwm.h"
#include "tm_stm32f4_general.h"
#include "tm_stm32f4_watchdog.h"
#include "tm_stm32f4_dht11.h"
#include "tm_stm32f4_dht21.h"
#include "DHT_Function.h"
#include "defines.h"							//Tu su definovane vsetky moje konstanty a premenne .........
#include "i2c-lcd.h"
#include "bmp180.h"
#include "bmp280.h"
#include "bme280.h"
#include "bme280_defs.h"
#include "ccs811.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "pidreg.h"

/* Include ARM math */
#include "arm_math.h"

#define	Number_Retries	(uint8_t)0x03		//Zopakujem 3x hladanie zariadenia na I2C ...

#define	OneHalfSecond		(uint32_t)500
#define	OneSecond				(uint32_t)(2*OneHalfSecond)
#define	TwoSecond				(uint32_t)(2*OneSecond)

#define	REGK0						(uint16_t)0x0000
#define	REGV0						(uint16_t)0x0001
#define	REGF0						(uint16_t)0x0004

//**************************************************************************************************************************************************************************************************************************************************
double_t xk[Numbers_Regulators],yk[Numbers_Regulators];
pid_params par[Numbers_Regulators],*ptr_par[Numbers_Regulators];
var_params var[Numbers_Regulators],*ptr_var[Numbers_Regulators];
//**************************************************************************************************************************************************************************************************************************************************
extern void Vypocet_PID_Konstant(pid_params*,uint8_t,uint8_t,double_t,double_t,double_t);
//**************************************************************************************************************************************************************************************************************************************************
extern pid_params pid[Numbers_Regulators];										//PID+ALE+TAK+PSD+DSP with LPF
//**************************************************************************************************************************************************************************************************************************************************
extern void init_pid_k0(pid_params*);
extern void init_pid_v0(pid_params*);
extern void init_ale_k0(pid_params*);
extern void init_ale_v0(pid_params*);
extern void init_tak_k0(pid_params*);
extern void init_tak_v0(pid_params*);
extern void init_psd_k0(pid_params*);
extern void init_psd_v0(pid_params*);
extern void init_dsp_k0(pid_params*);
extern void init_dsp_v0(pid_params*);
extern void init_arm_k0(pid_params*);
extern void init_arm_v0(pid_params*);
//**************************************************************************************************************************************************************************************************************************************************
extern void reg_pid_k0(double_t,double_t*,pid_params*,var_params*);	//PID with LPF
extern void reg_pid_v0(double_t,double_t*,pid_params*,var_params*);	//PID with LPF
extern void reg_ale_k0(double_t,double_t*,pid_params*,var_params*);	//Allen Bradley with LPF
extern void reg_ale_v0(double_t,double_t*,pid_params*,var_params*);	//Allen Bradley with LPF
extern void reg_tak_k0(double_t,double_t*,pid_params*,var_params*);	//Takahashi without LPF
extern void reg_tak_v0(double_t,double_t*,pid_params*,var_params*);	//Takahashi without LPF
extern void reg_psd_k0(double_t,double_t*,pid_params*,var_params*);	//Velocity PSD without LPF
extern void reg_psd_v0(double_t,double_t*,pid_params*,var_params*);	//Velocity PSD without LPF
extern void reg_dsp_k0(double_t,double_t*,pid_params*,var_params*);	//CMSIS DSP PID
extern void reg_dsp_v0(double_t,double_t*,pid_params*,var_params*);	//CMSIS DSP PID
extern void reg_arm_k0(double_t,double_t*,pid_params*,var_params*);	//Velocity PSD without LPF CMSIS DSP ARM
extern void reg_arm_v0(double_t,double_t*,pid_params*,var_params*);	//Velocity PSD without LPF CMSIS DSP ARM
//**************************************************************************************************************************************************************************************************************************************************

extern void delay_ms(uint32_t period_ms);
extern int8_t i2c_reg_write(uint8_t i2c_addr,uint8_t reg_addr,uint8_t *reg_data,uint16_t length);			//Zapis bloku na I2C s registrom !
extern int8_t i2c_reg_read(uint8_t i2c_addr,uint8_t reg_addr,uint8_t *reg_data,uint16_t length);			//Citanie bloku na I2C s registrom !
extern int8_t i2c_reg_write_no_register(uint8_t i2c_addr,uint8_t *reg_data,uint16_t length);					//Zapis blok na I2C bez registra ...
extern int8_t i2c_reg_read_no_register(uint8_t i2c_addr, uint8_t *reg_data, uint16_t length);					//Precita blok byte bez registra
extern int8_t i2c_write_no_register(uint8_t i2c_address, uint8_t data);																//Zapise 1 byte bez registra
extern int8_t i2c_read_no_register(uint8_t i2c_addr);																									//Precita 1 byte bez registra
extern int8_t i2c_write(uint8_t i2c_addr, uint8_t reg, uint8_t data);																	//Zapise 1 byte s registrom
extern int8_t i2c_read(uint8_t,uint8_t);																															//Precita 1 byte s registrom

enum {ON=0, OFF=1};

void EJ_DAC_Setting(TM_DAC_Channel_t DACx, float32_t duty_percent)
{
 uint16_t DAC_Value=(uint16_t)duty_percent*(4096.0/100.0);
 TM_DAC_SetValue(DACx, DAC_Value);
}

typedef struct _Time_
{
 int h,m,s,day,year;
}
Time;

Time Cas;

//TM_RTC_Time_t datatime;
//TM_DS1307_Time_t time;	//datatime

int16_t Vbat;

#define	SizeOfBuffer	(uint8_t)50

#ifdef SERIAL
char buf[SizeOfBuffer],str[SizeOfBuffer];
#endif

/* USART6 output stream handler = custom function name, linked with USART6 stream in the beginning of main() function */
int USART6_Stream_OutputFunction(int ch, FILE* f) 
{
	/* Send char via USART6 */
	TM_USART_Putc(USART6, (char) ch);
	/* Return ch, it means OK */
	return ch;
	/* If you want to return error, then you have to send EOF (-1) */
	//return -1;
}

/* Handle USART6 stream input = custom function name, linked with USART6 stream in the beginning of main() function */
int USART6_Stream_InputFunction(FILE* f) 
{
	/* If any data at USART, return them */
	/* Do your custom implementation here when string ends */
	if (!TM_USART_BufferEmpty(USART6)) 
	 {
		return (int)TM_USART_Getc(USART6);
	 }
	
	/* End of data, string is valid */
	/* You have to send -1 at the end of string */
	return -1;
}

/* Create global variables for fprintf function for USART6 */
FILE USART6_Stream;

#define MAX_POOL_OBJECTS	(uint8_t)3											// Bolo 50 a nefungovalo to tu ...
#define CCS_POOL_OBJECTS	(uint8_t)1											// Bolo 50 a nefungovalo to tu ...
#define LCD_POOL_OBJECTS	(uint8_t)1
#define DHT_POOL_OBJECTS	(uint8_t)1
#define BMP_POOL_OBJECTS	(uint8_t)1
#define BME_POOL_OBJECTS	(uint8_t)1

osMemoryPoolId_t DHT11_memPool;
osMemoryPoolId_t DHT21_memPool;
osMemoryPoolId_t BMP180_memPool;
osMemoryPoolId_t BME280_memPool;
osMemoryPoolId_t BME28x_memPool;
osMemoryPoolId_t BME28y_memPool;
osMemoryPoolId_t CCS811_memPool;
osMemoryPoolId_t CLOCK_memPool;
#ifdef LCD_MEMPOOL
osMemoryPoolId_t LCD_memPool;
#endif

//__attribute__((section(".bss.os.msgqueue.cb")))						//Tu to sice nehlasilo nic, ale pri deklaracii typu premennej je aj tato deklaracia ...
osMessageQueueId_t DHT11_msgQueue;
osMessageQueueId_t DHT21_msgQueue;
osMessageQueueId_t BMP180_msgQueue;
osMessageQueueId_t BME280_msgQueue;
osMessageQueueId_t BME28x_msgQueue;
osMessageQueueId_t BME28y_msgQueue;
osMessageQueueId_t CCS811_msgQueue;
osMessageQueueId_t CLOCK_msgQueue;

//__attribute__((section(".bss.os.evflags.cb")))						//Tu to sice nehlasilo nic, ale pri deklaracii typu premennej je aj tato deklaracia ...
osEventFlagsId_t clk_id,sek_id,led_id;
//__attribute__((section(".bss.os.thread.cb"))) 						//Hlasilo zvlastnu chybu TCB[i].stack_crub v RTX5 simulacnom okne a neslo vidiet environment RTX ....

void Error_Signal(void)
{
 while(1)
 {
	//TM_DISCO_SetLed(LED_GREEN,1);		//TM_DISCO_LedToggle(LED_GREEN);
	//TM_DISCO_SetLed(LED_ORANGE,1);	//TM_DISCO_LedToggle(LED_ORANGE);
	osEventFlagsSet(led_id,LED_GREEN|LED_ORANGE);
 }
}

#ifndef SIMUL

// Reserve two areas for the stacks of worker thread 1
// uint64_t makes sure the memory alignment is 8
//__attribute__((section(".bss.os.stack.cb")))
uint64_t bat_stmx_app_thread_stk[64];
uint64_t led_stmx_app_thread_stk[64];
uint64_t rot_encx_app_thread_stk[64];
uint64_t pwm_stmx_app_thread_stk[64];
uint64_t wdt_stmx_app_thread_stk[64];
uint64_t one_wire_app_thread_stk[128];
uint64_t ssd1306_i2cx_app_thread_stk[128];
uint64_t rtc1307_i2cx_app_thread_stk[128];
uint64_t bmp180_i2cx_app_thread_stk[128];
uint64_t bmp280_i2cx_app_thread_stk[128];
uint64_t bme280_i2cx_app_thread_stk[128];	//Musi tu byt dostatok pamati lebo float potrebuje viac pamati... RTX5 mrzlo po vykonani casti kodu ...
uint64_t ccs811_i2cx_app_thread_stk[128];
uint64_t reg_k000_app_thread_stk[256];
uint64_t reg_v000_app_thread_stk[256];
uint64_t clk_stmx_app_thread_stk[256];
uint64_t dht_dht11_app_thread_stk[256];
uint64_t dht_dht21_app_thread_stk[256];
uint64_t lcd_clkx_app_thread_stk[256];
uint64_t rtc_stmx_app_thread_stk[256];

// Define objects that are ally allocated for thread
//__attribute__((section(".bss.os.thread.cb")))
osRtxThread_t ssd1306_i2cx_app_thread_tcb;
osRtxThread_t bat_stmx_app_thread_tcb;
osRtxThread_t led_stmx_app_thread_tcb;
osRtxThread_t rot_encx_app_thread_tcb;
osRtxThread_t one_wire_app_thread_tcb;
osRtxThread_t pwm_stmx_app_thread_tcb;
osRtxThread_t rtc1307_i2cx_app_thread_tcb;
osRtxThread_t wdt_stmx_app_thread_tcb;
osRtxThread_t bmp180_i2cx_app_thread_tcb;
osRtxThread_t bmp280_i2cx_app_thread_tcb;
osRtxThread_t bme280_i2cx_app_thread_tcb;
osRtxThread_t ccs811_i2cx_app_thread_tcb;
osRtxThread_t reg_k000_app_thread_tcb;
osRtxThread_t reg_v000_app_thread_tcb;
osRtxThread_t clk_stmx_app_thread_tcb;
osRtxThread_t dht_dht11_app_thread_tcb;
osRtxThread_t dht_dht21_app_thread_tcb;
osRtxThread_t lcd_clkx_app_thread_tcb;
osRtxThread_t rtc_stmx_app_thread_tcb;

// Define the attributes which are used for thread creation
// Optional const saves RAM memory and includes the values in periodic ROM tests 
uint32_t param[OS_THREAD_DEF_STACK_NUM];	//Number of user Threads with default Stack size <0-1000>
																					//<i> Defines maximum number of user threads with default stack size.

const osThreadAttr_t reg_k000_app_attr=
{
  .name="regulator_k0_attr",
  .attr_bits=osThreadDetached,
  .cb_mem=&reg_k000_app_thread_tcb,
  .cb_size=sizeof(reg_k000_app_thread_tcb),
  .stack_mem=&reg_k000_app_thread_stk[0],
  .stack_size=sizeof(reg_k000_app_thread_stk),
  .priority=osPriorityAboveNormal,
	.tz_module=0U,
	.reserved=0U
};

const osThreadAttr_t reg_v000_app_attr=
{
  .name="regulator_v0_attr",
  .attr_bits=osThreadDetached,
  .cb_mem=&reg_v000_app_thread_tcb,
  .cb_size=sizeof(reg_v000_app_thread_tcb),
  .stack_mem=&reg_v000_app_thread_stk[0],
  .stack_size=sizeof(reg_v000_app_thread_stk),
  .priority=osPriorityAboveNormal,
	.tz_module=0U,
	.reserved=0U
};

const osThreadAttr_t clk_stmx_app_attr=
{
  .name="clock_app_attr",
  .attr_bits=osThreadDetached,
  .cb_mem=&clk_stmx_app_thread_tcb,
  .cb_size=sizeof(clk_stmx_app_thread_tcb),
  .stack_mem=&clk_stmx_app_thread_stk[0],
  .stack_size=sizeof(clk_stmx_app_thread_stk),
  .priority=osPriorityNormal,
	.tz_module=0U,
	.reserved=0U
};

const osThreadAttr_t dht_dht11_app_attr=
{
  .name="dht11_app_attr",
  .attr_bits=osThreadDetached,
  .cb_mem=&dht_dht11_app_thread_tcb,
  .cb_size=sizeof(dht_dht11_app_thread_tcb),
  .stack_mem=&dht_dht11_app_thread_stk[0],
  .stack_size=sizeof(dht_dht11_app_thread_stk),
  .priority=osPriorityNormal,
	.tz_module=0U,
	.reserved=0U
};

const osThreadAttr_t dht_dht21_app_attr=
{
  .name="dht21_app_attr",
  .attr_bits=osThreadDetached,
  .cb_mem=&dht_dht21_app_thread_tcb,
  .cb_size=sizeof(dht_dht21_app_thread_tcb),
  .stack_mem=&dht_dht21_app_thread_stk[0],
  .stack_size=sizeof(dht_dht21_app_thread_stk),
  .priority=osPriorityNormal,
	.tz_module=0U,
	.reserved=0U
};

const osThreadAttr_t lcd_clkx_app_attr=
{
  .name="lcd_clkx_app_attr",
  .attr_bits=osThreadDetached,
  .cb_mem=&lcd_clkx_app_thread_tcb,
  .cb_size=sizeof(lcd_clkx_app_thread_tcb),
  .stack_mem=&lcd_clkx_app_thread_stk[0],
  .stack_size=sizeof(lcd_clkx_app_thread_stk),
  .priority=osPriorityNormal,
	.tz_module=0U,
	.reserved=0U
};

const osThreadAttr_t rtc_stmx_app_attr=
{
  .name="rtc_stmx_app_attr",
  .attr_bits=osThreadDetached,
  .cb_mem=&rtc_stmx_app_thread_tcb,
  .cb_size=sizeof(rtc_stmx_app_thread_tcb),
  .stack_mem=&rtc_stmx_app_thread_stk[0],
  .stack_size=sizeof(rtc_stmx_app_thread_stk),
  .priority=osPriorityNormal,
	.tz_module=0U,
	.reserved=0U
};

const osThreadAttr_t ssd1306_i2cx_app_attr=
{
  .name="ssd1306_i2cx_app_attr",
  .attr_bits=osThreadDetached,
  .cb_mem=&ssd1306_i2cx_app_thread_tcb,
  .cb_size=sizeof(ssd1306_i2cx_app_thread_tcb),
  .stack_mem=&ssd1306_i2cx_app_thread_stk[0],
  .stack_size=sizeof(ssd1306_i2cx_app_thread_stk),
  .priority=osPriorityNormal,
	.tz_module=0U,
	.reserved=0U
};

const osThreadAttr_t bat_stmx_app_attr=
{
  .name="bat_stmx_app_attr",
  .attr_bits=osThreadDetached,
  .cb_mem=&bat_stmx_app_thread_tcb,
  .cb_size=sizeof(bat_stmx_app_thread_tcb),
  .stack_mem=&bat_stmx_app_thread_stk[0],
  .stack_size=sizeof(bat_stmx_app_thread_stk),
  .priority=osPriorityNormal,
	.tz_module=0U,
	.reserved=0U
};

const osThreadAttr_t led_stmx_app_attr=
{
  .name="led_stmx_app_attr",
  .attr_bits=osThreadDetached,
  .cb_mem=&led_stmx_app_thread_tcb,
  .cb_size=sizeof(led_stmx_app_thread_tcb),
  .stack_mem=&led_stmx_app_thread_stk[0],
  .stack_size=sizeof(led_stmx_app_thread_stk),
  .priority=osPriorityNormal,
	.tz_module=0U,
	.reserved=0U
};

const osThreadAttr_t rot_encx_app_attr=
{
  .name="rot_encx_app_attr",
  .attr_bits=osThreadDetached,
  .cb_mem=&rot_encx_app_thread_tcb,
  .cb_size=sizeof(rot_encx_app_thread_tcb),
  .stack_mem=&rot_encx_app_thread_stk[0],
  .stack_size=sizeof(rot_encx_app_thread_stk),
  .priority=osPriorityNormal,
	.tz_module=0U,
	.reserved=0U
};

const osThreadAttr_t bmp180_i2cx_app_attr=
{
  .name="bmp180_i2cx_app_attr",
  .attr_bits=osThreadDetached,
  .cb_mem=&bmp180_i2cx_app_thread_tcb,
  .cb_size=sizeof(bmp180_i2cx_app_thread_tcb),
  .stack_mem=&bmp180_i2cx_app_thread_stk[0],
  .stack_size=sizeof(bmp180_i2cx_app_thread_stk),
  .priority=osPriorityNormal,
	.tz_module=0U,
	.reserved=0U
};

const osThreadAttr_t one_wire_app_attr=
{
  .name="one_wire_app_attr",
  .attr_bits=osThreadDetached,
  .cb_mem=&one_wire_app_thread_tcb,
  .cb_size=sizeof(one_wire_app_thread_tcb),
  .stack_mem=&one_wire_app_thread_stk[0],
  .stack_size=sizeof(one_wire_app_thread_stk),
  .priority=osPriorityNormal,
	.tz_module=0U,
	.reserved=0U
};

const osThreadAttr_t pwm_stmx_app_attr=
{
  .name="pwm_stmx_app_attr",
  .attr_bits=osThreadDetached,
  .cb_mem=&pwm_stmx_app_thread_tcb,
  .cb_size=sizeof(pwm_stmx_app_thread_tcb),
  .stack_mem=&pwm_stmx_app_thread_stk[0],
  .stack_size=sizeof(pwm_stmx_app_thread_stk),
  .priority=osPriorityNormal,
	.tz_module=0U,
	.reserved=0U
};

const osThreadAttr_t rtc1307_i2cx_app_attr=
{
  .name="rtc1307_i2cx_app_attr",
  .attr_bits=osThreadDetached,
  .cb_mem=&rtc1307_i2cx_app_thread_tcb,
  .cb_size=sizeof(rtc1307_i2cx_app_thread_tcb),
  .stack_mem=&rtc1307_i2cx_app_thread_stk[0],
  .stack_size=sizeof(rtc1307_i2cx_app_thread_stk),
  .priority=osPriorityNormal,
	.tz_module=0U,
	.reserved=0U
};

const osThreadAttr_t wdt_stmx_app_attr=
{
  .name="wdt_stmx_app_attr",
  .attr_bits=osThreadDetached,
  .cb_mem=&wdt_stmx_app_thread_tcb,
  .cb_size=sizeof(wdt_stmx_app_thread_tcb),
  .stack_mem=&wdt_stmx_app_thread_stk[0],
  .stack_size=sizeof(wdt_stmx_app_thread_stk),
  .priority=osPriorityHigh,
	.tz_module=0U,
	.reserved=0U
};

const osThreadAttr_t bmp280_i2cx_app_attr=
{
  .name="bmp280_i2cx_app_attr",
  .attr_bits=osThreadDetached,
  .cb_mem=&bmp280_i2cx_app_thread_tcb,
  .cb_size=sizeof(bmp280_i2cx_app_thread_tcb),
  .stack_mem=&bmp280_i2cx_app_thread_stk[0],
  .stack_size=sizeof(bmp280_i2cx_app_thread_stk),
  .priority=osPriorityNormal,
	.tz_module=0U,
	.reserved=0U
};

const osThreadAttr_t bme280_i2cx_app_attr=
{
  .name="bme280_i2cx_app_attr",
  .attr_bits=osThreadDetached,
  .cb_mem=&bme280_i2cx_app_thread_tcb,
  .cb_size=sizeof(bme280_i2cx_app_thread_tcb),
  .stack_mem=&bme280_i2cx_app_thread_stk[0],
  .stack_size=sizeof(bme280_i2cx_app_thread_stk),
  .priority=osPriorityNormal,
	.tz_module=0U,
	.reserved=0U
};

const osThreadAttr_t ccs811_i2cx_app_attr=
{
  .name="ccs811_i2cx_app_attr",
  .attr_bits=osThreadDetached,
  .cb_mem=&ccs811_i2cx_app_thread_tcb,
  .cb_size=sizeof(ccs811_i2cx_app_thread_tcb),
  .stack_mem=&ccs811_i2cx_app_thread_stk[0],
  .stack_size=sizeof(ccs811_i2cx_app_thread_stk),
  .priority=osPriorityNormal,
	.tz_module=0U,
	.reserved=0U
};

#endif

//Mutex-y pre "zdielane" komunikacne rozhrania viacerymi taskami, je to obdoba semaforov z RTX51 pre C51 ...

const osMutexAttr_t Thread_232_Mutex_attr = 
{
 .name="My_RS232_Mutex",				// human readable mutex name
 .attr_bits=osMutexPrioInherit, // attr_bits
 .cb_mem=NULL,                	// memory for control block, NULL to use Automatic Dynamic Allocation for the mutex control block.
 .cb_size=0U                   	// size for control block
};

const osMutexAttr_t Thread_236_Mutex_attr = 
{
 .name="My_USART6_Mutex",				// human readable mutex name
 .attr_bits=osMutexPrioInherit, // attr_bits
 .cb_mem=NULL,                	// memory for control block, NULL to use Automatic Dynamic Allocation for the mutex control block.
 .cb_size=0U                   	// size for control block
};

const osMutexAttr_t Thread_I2C_Mutex_attr = 
{
 .name="My_I2C_Mutex",					// human readable mutex name
 .attr_bits=osMutexPrioInherit, // attr_bits
 .cb_mem=NULL,                	// memory for control block, NULL to use Automatic Dynamic Allocation for the mutex control block.
 .cb_size=0U                   	// size for control block
};

const osMutexAttr_t Thread_SPI_Mutex_attr = 
{
 .name="My_SPI_Mutex",					// human readable mutex name
 .attr_bits=osMutexPrioInherit, // attr_bits
 .cb_mem=NULL,                	// memory for control block, NULL to use Automatic Dynamic Allocation for the mutex control block.
 .cb_size=0U                   	// size for control block
};

const osMutexAttr_t Thread_ONE_Mutex_attr = 
{
 .name="My_ONEWIRE_Mutex",			// human readable mutex name
 .attr_bits=osMutexPrioInherit, // attr_bits
 .cb_mem=NULL,                	// memory for control block, NULL to use Automatic Dynamic Allocation for the mutex control block.
 .cb_size=0U                   	// size for control block
};

osMutexId_t mutex_usart1_id;
osMutexId_t mutex_usart6_id;
osMutexId_t mutex_i2c_id;
osMutexId_t mutex_spi_id;
osMutexId_t mutex_one_id;

#define	SIG_TIME_ONESEC		(uint16_t)0x0001
#define	SIG_TIME_HALFSEC	(uint16_t)0x0002
#define	SIG_TIME_REFRESH	(uint16_t)0x0004

/* Called on wakeup interrupt */
void TM_RTC_RequestHandler(void) 
{
	osEventFlagsSet(sek_id,SIG_TIME_HALFSEC);
}

/* Rotary encoder data */
TM_RE_t RE1_Data,RE2_Data;

/* TM EXTI Handler for all EXTI lines */
void TM_EXTI_Handler(uint16_t GPIO_Pin) 
{
	/* Check RE pin 1 */
	if (GPIO_Pin == RE1_Data.GPIO_PIN_A) 
	{
		/* Process data */
		//TM_RE_Process(&RE1_Data);
	}
	if (GPIO_Pin == RE2_Data.GPIO_PIN_A) 
	{
		/* Process data */
		//TM_RE_Process(&RE2_Data);
	}
} 

extern void reg_fuz_k0(double_t xk, double_t *yk, pid_params *p, var_params *v);

float32_t Heating_For_Scaling(uint8_t Index_Regulator, float32_t X, float32_t Temperature_Offset)
{
 enum {A=0,B=1};
 extern const float32_t HeatingCurve[24][2];
 X-=Temperature_Offset;
 return(HeatingCurve[ptr_par[Index_Regulator]->Ekviterm][A] * X + HeatingCurve[ptr_par[Index_Regulator]->Ekviterm][B]);	//Posuniem o offset do zapornych cisel ...
}

__NO_RETURN void reg_k000_app(void *argument) 
{
	(void)argument;
	TM_DISCO_SetLed(LED_ORANGE,1);
	/* Initialize ADC1 on channel 0, this is pin PA0 */
	TM_ADC_Init(ADC1,ADC_Channel_0);
	/* Initialize DAC channel 1,pin PA4 */
	TM_DAC_Init(TM_DAC1);
  for(;;)
	{
	 osDelay(K_TMO);
	 xk[REGK0]=Heating_For_Scaling(REGK0,TM_ADC_Read(ADC1,ADC_Channel_0)*(100.0/4096.0),50.0);		//Nacitam skutocnu hodnotu nameranu na AD prevodniku ...	 
 	 switch(ptr_par[REGK0]->pid_model)
	  {
	 	 default	:																																					//ak nie je zvoleny ziaden regulator, tak musi byt spusteny defaultne vypnuty PID a to je tu s parametrom par[REGK0]->pid_model=0
		 case	PID	:	reg_pid_k0(xk[REGK0],&yk[REGK0],ptr_par[REGK0],ptr_var[REGK0]); break;	//Doplnene o vypocet na zaklade vykurovacej krivky - Heating Curve
		 case	ALE	:	reg_ale_k0(xk[REGK0],&yk[REGK0],ptr_par[REGK0],ptr_var[REGK0]); break;	//Doplnene o vypocet na zaklade vykurovacej krivky - Heating Curve
		 case	TAK	:	reg_tak_k0(xk[REGK0],&yk[REGK0],ptr_par[REGK0],ptr_var[REGK0]); break;	//Doplnene o vypocet na zaklade vykurovacej krivky - Heating Curve
		 case	PSD	:	reg_psd_k0(xk[REGK0],&yk[REGK0],ptr_par[REGK0],ptr_var[REGK0]); break;	//Doplnene o vypocet na zaklade vykurovacej krivky - Heating Curve
	   case	DSP	:	reg_dsp_k0(xk[REGK0],&yk[REGK0],ptr_par[REGK0],ptr_var[REGK0]); break;	//Doplnene o vypocet na zaklade vykurovacej krivky - Heating Curve
		 case	ARM	:	reg_arm_k0(xk[REGK0],&yk[REGK0],ptr_par[REGK0],ptr_var[REGK0]); break;	//Doplnene o vypocet na zaklade vykurovacej krivky - Heating Curve
		 case	FUZ	:	reg_arm_k0(xk[REGK0],&yk[REGK0],ptr_par[REGK0],ptr_var[REGK0]); break;	//Doplnene o vypocet na zaklade vykurovacej krivky - Heating Curve
	  }		
	 EJ_DAC_Setting(TM_DAC1,yk[REGK0]);																										//Nastavim akcny zasah do regulovanej sustavy cez DAC prevodnik ....
	 osEventFlagsSet(led_id,LED_ORANGE);
	}
}
 
__NO_RETURN void reg_v000_app(void *argument) 
{
 (void)argument;
//	osStatus_t status;
	TM_DISCO_SetLed(LED_GREEN,1);
	/* Initialize ADC1 on channel 1, this is pin PA1 */
	TM_ADC_Init(ADC1,ADC_Channel_1);
	/* Initialize DAC channel 2,pin PA5 */
	TM_DAC_Init(TM_DAC2);
  for(;;)
	{
	 osDelay(K_TMO);
	 xk[REGV0]=(TM_ADC_Read(ADC1,ADC_Channel_1)*(100.0/4096.0));														//Nacitam skutocnu hodnotu nameranu na AD prevodniku ...
	 switch(ptr_par[REGV0]->pid_model)
		{
		 default	:																																					//ak nie je zvoleny ziaden regulator, tak musi byt spusteny defaultne vypnuty PID a to je tu s parametrom par[REGK0]->pid_model=0
		 case	PID	:	reg_pid_v0(xk[REGV0],&yk[REGV0],ptr_par[REGV0],ptr_var[REGV0]); break;	//Doplnene o vypocet na zaklade vykurovacej krivky - Heating Curve
		 case	ALE	:	reg_ale_v0(xk[REGV0],&yk[REGV0],ptr_par[REGV0],ptr_var[REGV0]); break;	//Doplnene o vypocet na zaklade vykurovacej krivky - Heating Curve
		 case	TAK	:	reg_tak_v0(xk[REGV0],&yk[REGV0],ptr_par[REGV0],ptr_var[REGV0]); break;	//Doplnene o vypocet na zaklade vykurovacej krivky - Heating Curve
		 case	PSD	:	reg_psd_v0(xk[REGV0],&yk[REGV0],ptr_par[REGV0],ptr_var[REGV0]); break;	//Doplnene o vypocet na zaklade vykurovacej krivky - Heating Curve
		 case	DSP	:	reg_dsp_v0(xk[REGV0],&yk[REGV0],ptr_par[REGV0],ptr_var[REGV0]); break;	//Doplnene o vypocet na zaklade vykurovacej krivky - Heating Curve
		 case	ARM	:	reg_arm_v0(xk[REGK0],&yk[REGK0],ptr_par[REGK0],ptr_var[REGK0]); break;	//Doplnene o vypocet na zaklade vykurovacej krivky - Heating Curve
		 //case	FUZ	:	reg_fuz_k0(xk[REGK0],&yk[REGK0],ptr_par[REGK0],ptr_var[REGK0]); break;	//Doplnene o vypocet na zaklade vykurovacej krivky - Heating Curve
		}
	 EJ_DAC_Setting(TM_DAC2,yk[REGV0]);																										//Nastavim akcny zasah do regulovanej sustavy cez DAC prevodnik ....
	 osEventFlagsSet(led_id,LED_GREEN);
	}
}

__NO_RETURN void clk_stmx_app(void *argument) 
{
	(void)argument;
  for(;;)
	{
	 switch((int32_t)osEventFlagsWait(clk_id,SIG_TIME_ONESEC,osFlagsWaitAny,TwoSecond))
	  {
		 case	SIG_TIME_ONESEC			:		
																	#ifdef SERIAL
																	osMutexAcquire(mutex_usart1_id,osWaitForever);
																	if(TM_USART_BufferEmpty(USART1))
																	 {
																		sprintf(buf,"%02d.%02d.%04d %02d:%02d:%02d\n\r",datatime.date,datatime.month,datatime.year+2000,datatime.hours,datatime.minutes,datatime.seconds);
																		TM_USART_Puts(USART1,buf);
																	 }
																	osMutexRelease(mutex_usart1_id);
																	osMutexAcquire(mutex_usart6_id,osWaitForever);
																	if(TM_USART_BufferEmpty(USART6)) fprintf(&USART6_Stream,"%02d.%02d.%04d %02d:%02d:%02d\n\r",datatime.date,datatime.month,datatime.year+2000,datatime.hours,datatime.minutes,datatime.seconds);
																	osMutexRelease(mutex_usart6_id);
																	#endif
		 case	osOK									:	break;
		 case	osFlagsErrorISR				:	
		 case	osFlagsErrorUnknown		:	
		 case	osFlagsErrorParameter	:	
		 case	osFlagsErrorResource	:	
		 case	osFlagsErrorTimeout		:	
		 default										:	osEventFlagsClear(clk_id,osEventFlagsGet(clk_id));
																	break;
		}
	}
}

typedef void(*dht_exe_fptr_t)(DHT_msg_t*);																	//Definicia funkcie ktora je volana ....

struct dht_device																														//API device structure and API Calls ...
{
 DHT_msg_t dht;
 dht_exe_fptr_t read;																												//dht_exe_fptr_t read;
};

struct ccs_device																														//API device structure and API Calls ...
{
 ccs811_dev_t ccs;
 ccs811_func_ptr read,write;
};

void dht11_read(struct dht_device *device) {device->read(&device->dht);}		//Rovnaka procedura pre DHT11 a DHT21 ...
void dht21_read(struct dht_device *device) {device->read(&device->dht);}		//Rovnaka procedura pre DHT11 a DHT21 ...
void bmp180_read(struct dht_device *device) {device->read(&device->dht);}		//Rovnaka procedura pre DHT11 a DHT21 ...
void bme280_read(struct dht_device *device) {device->read(&device->dht);}		//Rovnaka procedura pre DHT11 a DHT21 ...

/*
void dht11_read(struct dht_device *device) {device->read(&device->dht,device->dht.temperature,device->dht.humidity,device->dht.pressure);}		//Rovnaka procedura pre DHT11 a DHT21 ...
void dht21_read(struct dht_device *device) {device->read(&device->dht,device->dht.temperature,device->dht.humidity,device->dht.pressure);}		//Rovnaka procedura pre DHT11 a DHT21 ...
void bmp180_read(struct dht_device *device) {device->read(&device->dht,device->dht.temperature,device->dht.humidity,device->dht.pressure);}		//Rovnaka procedura pre DHT11 a DHT21 ...
void bme280_read(struct dht_device *device) {device->read(&device->dht,device->dht.temperature,device->dht.humidity,device->dht.pressure);}		//Rovnaka procedura pre DHT11 a DHT21 ...
*/
extern const ccs811_alg_results_t ccs811_init_value;
extern const DHT_msg_t DHT_Init;
	
__NO_RETURN void dht_dht11_app(void *argument) 
{
	(void)argument;
	uint8_t Count;
	struct dht_device dht11;
	TM_DHT11_Data_t dht11_data;
	TM_DHT11_t rslt;
	DHT_msg_t*msg;
	osStatus_t status;
  DHT11_msgQueue=osMessageQueueNew(DHT_POOL_OBJECTS,sizeof(DHT_msg_t*),NULL);	// Message queue used to pass pointers to msg_t
  DHT11_memPool=osMemoryPoolNew(DHT_POOL_OBJECTS,sizeof(DHT_msg_t),NULL);			// Memory pool for actual message objects
	while((TM_DHT11_Init()!=TM_DHT11_OK)) osDelay(TwoSecond);										//Initialize DHT11 -> PD1, nekontroluje pritomnost DHT11 na porte !!!
	do
	{
	 switch(Count)
		{
			default							:	Count++;
														rslt=TM_DHT11_Read(&dht11_data);
														break;
			case Number_Retries	: Count=Number_Retries;
														break;
		}	
	 osDelay(TwoSecond);
	}
	while(rslt!=TM_DHT11_OK);
	memcpy(&dht11.dht,&DHT_Init,sizeof(DHT_msg_t));																	//Inicializujem DHT stukturu z tabulky ....
  for(;;)
	{
	 if(TM_DHT11_Read(&dht11_data)==TM_DHT11_OK)
	  {
		 dht11.dht.temperature=(float32_t)dht11_data.Temp/10;
		 dht11.dht.humidity=(float32_t)dht11_data.Hum/10;
		 dht11.read=(dht_exe_fptr_t)&DHT_Compute_Propiertys;
		 dht11_read(&dht11);																							//Tymto naplnim len strukturu dht11 a o sebe nevedia ...
		 msg=(DHT_msg_t*)osMemoryPoolAlloc(DHT11_memPool,osWaitForever);	//Alokujem pamat pre odosielanu spravu ...
		 if(msg != NULL) memcpy(msg,&dht11.dht,sizeof(DHT_msg_t));				//Pridelilo mi pamat ?, ak ano tak kopirujem data na odoslanie ...
		 status=osMessageQueuePut(DHT11_msgQueue,&msg,0U,osWaitForever);	//Odosielam spravu na msgQueue ...
		 while(status != osOK) Error_Signal();														//Bolo to OK, alebo chyba ...
		 /* Print something on USART1 */
		 #ifdef SERIAL
		 if(TM_USART_BufferEmpty(USART1))
		  {
			 sprintf(str,"t=%+2.1fC\n\rh=%2.1f%%\n\r",dht11.dht.temperature,dht11.dht.humidity); 
			 osMutexAcquire(mutex_usart1_id,osWaitForever);
			 TM_USART_Puts(USART1,str);
			 osMutexRelease(mutex_usart1_id);
		  }
		 #endif	
	  }
	 osDelay(TwoSecond);																								//Meriam kazde 2 sekundy, castejsie je uplne zbytocne ....	
	}
}

__NO_RETURN void dht_dht21_app(void *argument) 
{
	(void)argument;
	uint8_t Count;
	struct dht_device dht21;	
	TM_DHT21_t rslt;
	TM_DHT21_Data_t dht21_data;
	DHT_msg_t *msg;
	osStatus_t status;
  DHT21_msgQueue=osMessageQueueNew(DHT_POOL_OBJECTS,sizeof(DHT_msg_t*),NULL);	// Message queue used to pass pointers to msg_t
  DHT21_memPool=osMemoryPoolNew(DHT_POOL_OBJECTS,sizeof(DHT_msg_t),NULL);			// Memory pool for actual message objects
	while((TM_DHT21_Init()!=TM_DHT21_OK)) osDelay(TwoSecond);										//Initialize DHT21 -> PD11, nekontroluje pritomnost DHT21 na porte !!!
	do
	{
	 switch(Count)
		{
			default							:	Count++;
														rslt=TM_DHT21_Read(&dht21_data);
														break;
			case Number_Retries	: Count=Number_Retries;
														break;
		}
	 osDelay(TwoSecond);
	}
	while(rslt!=TM_DHT21_OK);
	memcpy(&dht21.dht,&DHT_Init,sizeof(DHT_msg_t));																	//Inicializujem DHT stukturu z tabulky ....
  for(;;)
	{
	 if(TM_DHT21_Read(&dht21_data)==TM_DHT21_OK)
	  {
		 dht21.dht.temperature=(float32_t)dht21_data.Temp/10;
		 dht21.dht.humidity=(float32_t)dht21_data.Hum/10;
		 dht21.read=(dht_exe_fptr_t)&DHT_Compute_Propiertys;
		 dht21_read(&dht21);																													//Tymto naplnim len strukturu dht21 a o sebe nevedia ...
		 msg=(DHT_msg_t*)osMemoryPoolAlloc(DHT21_memPool,osWaitForever);
		 if(msg != NULL) memcpy(msg,&dht21.dht,sizeof(DHT_msg_t));
		 status=osMessageQueuePut(DHT21_msgQueue,&msg,0U,osWaitForever);
		 while(status != osOK) Error_Signal();
		 #ifdef SERIAL
		 if(TM_USART_BufferEmpty(USART6))
			{
			/* Print something on USART6 */
			//osMutexAcquire(mutex_usart6_id,osWaitForever);
			//fprintf(&USART6_Stream,"t=%+2.1fC\n\rh=%2.1f%%\n\r",DHT21.temperature,DHT21.humidity);	//Overene na M520 osciloskope, funguje ...
			//osMutexRelease(mutex_usart6_id);
			}
		 #endif	
	  }
	 osDelay(TwoSecond);																														//Meriam kazde 2 sekundy, castejsie je uplne zbytocne ....	
	}
}

__NO_RETURN void lcd_clkx_app(void *argument) 								//with I2C expander PCF8574 for LCD Display Hitachi HD44780
{
	(void)argument;
	#define	Sec_Mask	(uint8_t)0x01
	#define Stupen		(uint8_t)0xDF
	#define Set_Zero	(uint8_t)0x00
	#define Set_Space	(uint8_t)' '
	#define	End_Line	(uint8_t)'\0'
	#define	LCD_BACKLIGHT_OFF (uint8_t)0x00											//0x00 -> LCD_BACKLIGHT=OFF, 0x08 -> LCD_BACKLIGHT=ON
	#define	LCD_BACKLIGHT_ON 	(uint8_t)0x08											//0x00 -> LCD_BACKLIGHT=OFF, 0x08 -> LCD_BACKLIGHT=ON
	osStatus_t status;
	uint8_t i,Sekundovka=0x00;
	TM_RTC_Time_t CLOCK,*CLOCK_msg;
	ccs811_alg_results_t CCS811,*CCS811_msg;
	DHT_msg_t DHT11,DHT21,BMP180,BME280,*DHT11_msg,*DHT21_msg,*BMP180_msg,*BME280_msg;	//Kvoli MessageQueue pre DHT11, CLOCK, BME280 ....
	#ifdef LCD_MEMPOOL
		LCD_Buffer_t *Lcd_Actual_Display;																							//Nastavim pocet riadkov LCD_ROWS
		LCD_memPool=osMemoryPoolNew(LCD_POOL_OBJECTS,sizeof(LCD_Buffer_t),NULL);			// Memory pool for actual message objects
		if(LCD_memPool != NULL) Lcd_Actual_Display=(LCD_Buffer_t*)osMemoryPoolAlloc(LCD_memPool,NULL); else Error_Signal(); 
	#else
		Lcd_Line_Buffer Actual_Screen[LCD_ROWS];																//Nastavim pocet riadkov LCD_ROWS
		memset(Actual_Screen,Set_Space,sizeof(Actual_Screen));
	#endif

	memcpy(&DHT11,&DHT_Init,sizeof(DHT_msg_t));
	memcpy(&DHT21,&DHT_Init,sizeof(DHT_msg_t));
	memcpy(&BME280,&DHT_Init,sizeof(DHT_msg_t));
	memcpy(&CCS811,&ccs811_init_value,sizeof(ccs811_alg_results_t));

	osDelay(OneHalfSecond);																			//Musi to tu byt aby sa spravne inicializoval LCD, pozor na stary zeleny display, nestiha s vyssou I2C ako 100kHz a CCS811 viac ako 400kHz ...
	lcd_init(LCD_BACKLIGHT_OFF);
	osDelay(OneHalfSecond);
	for(;;)
	{
	 switch((int32_t)osEventFlagsWait(sek_id,SIG_TIME_HALFSEC|SIG_TIME_REFRESH,osFlagsWaitAny,osWaitForever))
	  {
			case	osOK							:
			case	SIG_TIME_HALFSEC	:
			case	SIG_TIME_REFRESH	:		Sekundovka^=Sec_Mask;
			
																	status=osMessageQueueGet(DHT11_msgQueue,&DHT11_msg,NULL,NULL);	//Mam prijatu spravu v Queue ???
																	if((status == osOK) && (DHT11_msg != NULL)) 
																	 {
																		memcpy(&DHT11,DHT11_msg,sizeof(DHT_msg_t));										//Kopirujem obsah message do DHT struktury ...
																		status=osMemoryPoolFree(DHT11_memPool,DHT11_msg);
																	 }
																	
																	status=osMessageQueueGet(DHT21_msgQueue,&DHT21_msg,NULL,NULL);	//Mam prijatu spravu v Queue ???
																	if((status == osOK) && (DHT21_msg != NULL)) 
																	 {
																		memcpy(&DHT21,DHT21_msg,sizeof(DHT_msg_t));										//Kopirujem obsah message do DHT struktury ...
																		status=osMemoryPoolFree(DHT21_memPool,DHT21_msg);
																	 }

																	status=osMessageQueueGet(BMP180_msgQueue,&BMP180_msg,NULL,NULL);//Mam prijatu spravu v Queue ???
																	if((status == osOK) && (BMP180_msg != NULL)) 
																	 {
																		memcpy(&BMP180,BMP180_msg,sizeof(DHT_msg_t));									//Kopirujem obsah message do DHT-BME struktury ...
																		status=osMemoryPoolFree(BMP180_memPool,BMP180_msg);
																	 }

																	status=osMessageQueueGet(BME280_msgQueue,&BME280_msg,NULL,NULL);//Mam prijatu spravu v Queue ???
																	if((status == osOK) && (BME280_msg != NULL)) 
																	 {
																		memcpy(&BME280,BME280_msg,sizeof(DHT_msg_t));									//Kopirujem obsah message do DHT-BME struktury ...
																		status=osMemoryPoolFree(BME280_memPool,BME280_msg);
																	 }

																	status=osMessageQueueGet(CCS811_msgQueue,&CCS811_msg,NULL,NULL);//Mam prijatu spravu v Queue ???
																	if((status == osOK) && (CCS811_msg != NULL)) 
																	 {
																		memcpy(&CCS811,CCS811_msg,sizeof(ccs811_alg_results_t));			//Kopirujem obsah message do DHT-BME struktury ...
																		status=osMemoryPoolFree(CCS811_memPool,CCS811_msg);
																	 }

																	status=osMessageQueueGet(CLOCK_msgQueue,&CLOCK_msg,NULL,NULL);	//Mam prijatu spravu v Queue ???
																	if((status == osOK) && (CLOCK_msg != NULL)) 
																	 {
																		memcpy(&CLOCK,CLOCK_msg,sizeof(TM_RTC_Time_t));								//Kopirujem obsah message do DHT-BME struktury ...
																		status=osMemoryPoolFree(CLOCK_memPool,CLOCK_msg);
																	 }
																										
																	#ifdef LCD_MEMPOOL
																		i=0x00;
																		snprintf((char*)&Lcd_Actual_Display[i++],sizeof(Lcd_Line_Buffer),"%02u%c%02u:%02u,%02u.%02u.%4u.",CLOCK.hours,Sekundovka?':':' ',CLOCK.minutes,CLOCK.seconds,CLOCK.date,CLOCK.month,CLOCK.year+2000);															
																		snprintf((char*)&Lcd_Actual_Display[i++],sizeof(Lcd_Line_Buffer),"%+2.2f%cC,%2.0f%%,%3.0fhPa",BME280.temperature,Stupen,BME280.humidity,BME280.pressure/100);
																		snprintf((char*)&Lcd_Actual_Display[i++],sizeof(Lcd_Line_Buffer),"HeatId:%+2.2f%cC,PE:%-.1u",BME280.HeatIndex,Stupen,BME280.Perception);																	
																		snprintf((char*)&Lcd_Actual_Display[i++],sizeof(Lcd_Line_Buffer),"eCO2=%-.4u,TVOC=%-.4u",CCS811.eCO2,CCS811.TVOC);	
																	#else
																	  i=0x00;
																		snprintf((char*)&Actual_Screen[i++],LCD_COLUMNS,"%02u%c%02u:%02u,%02u.%02u.%4u.",CLOCK.hours,(Sekundovka==0x00)?':':' ',CLOCK.minutes,CLOCK.seconds,CLOCK.date,CLOCK.month,CLOCK.year+2000);
																		snprintf((char*)&Actual_Screen[i++],LCD_COLUMNS,"%+2.2f%cC,%2.0f%%,%3.0fhPa",BME280.temperature,Stupen,BME280.humidity,(float32_t)BME280.pressure/100);
																		snprintf((char*)&Actual_Screen[i++],LCD_COLUMNS,"HeatId:%+2.2f%cC,PE:%-.1u",BME280.HeatIndex,Stupen,BME280.Perception);
																		snprintf((char*)&Actual_Screen[i++],LCD_COLUMNS,"eCO2=%-.4u,TVOC=%-.4u",CCS811.eCO2,CCS811.TVOC);
																	#endif
																	
																	osMutexAcquire(mutex_i2c_id,osWaitForever);
																	
																	#ifdef LCD_MEMPOOL
																		for(i=0x00; i<LCD_ROWS; i++) Lcd_Refresh_Display(i,(uint8_t*)&Lcd_Actual_Display[i],LCD_BACKLIGHT_ON);						// goto 0,1 az 3,1
																	#else
																		for(i=0x00; i<LCD_ROWS; i++) Lcd_Refresh_Display(i,(uint8_t*)&Actual_Screen[i],LCD_BACKLIGHT_ON);						// goto 0,1 az 3,1
																	#endif
																	
																	osMutexRelease(mutex_i2c_id);
																
																break;
			case	osError						:	break;
			case	osErrorTimeout		:
			case	osErrorParameter	:
			case	osErrorResource		:
			case	osErrorNoMemory		:
			case	osStatusReserved	:
			case	osErrorISR				:	break;
			default									:	osEventFlagsClear(sek_id,osEventFlagsGet(sek_id));
																break;
		}
	}
}

TM_RTC_Time_t datatime;

__NO_RETURN void rtc_stmx_app(void *argument) 
{
	(void)argument;
	uint8_t i;
	osStatus_t status;
	const char *Month[]={"Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"};
	const char month[sizeof(Month[0])];
	const char Date[]=__DATE__,Time[]=__TIME__;
	TM_RTC_Time_t* msg;
  CLOCK_msgQueue=osMessageQueueNew(CCS_POOL_OBJECTS,sizeof(TM_RTC_Time_t*),NULL);	// Message queue used to pass pointers to ccs811_alg_results_t
  CLOCK_memPool=osMemoryPoolNew(CCS_POOL_OBJECTS,sizeof(TM_RTC_Time_t),NULL);			// Memory pool for actual message objects
	//TM_RTC_Interrupts(TM_RTC_Int_500ms);
	/* Initialize RTC with internal 32.768kHz clock */
	/* It's very accurate XTAL=PC14 & PC15*/
	#ifdef ExternalSource
	//TM_RTC_Init(TM_RTC_ClockSource_External);
	if(!TM_RTC_Init(TM_RTC_ClockSource_External))
	#else
	//TM_RTC_Init(TM_RTC_ClockSource_Internal);
	if(!TM_RTC_Init(TM_RTC_ClockSource_Internal))
	#endif
	{
		sscanf(Time,"%02u:%02u:%02u",&Cas.h,&Cas.m,&Cas.s);
		sscanf(Date,"%3s %02u %04u",(char*)month,&Cas.day,&Cas.year);
		i=0;
		while(memcmp(month,Month[i++],sizeof(Month[i]))!=0);	
		datatime.hours=(uint8_t)Cas.h;
		datatime.minutes=(uint8_t)Cas.m;
		datatime.seconds=(uint8_t)Cas.s;
		datatime.year=(uint8_t)(Cas.year-2000);
		datatime.date=(uint8_t)Cas.day;
		datatime.month=i;
		datatime.day=1;
		/* Set new time */
		TM_RTC_SetDateTime(&datatime,TM_RTC_Format_BIN);
	}
	TM_RTC_Interrupts(TM_RTC_Int_500ms);
	for(;;)
	{
	 TM_RTC_GetDateTime(&datatime,TM_RTC_Format_BIN);
	 //Send Message to queue ....
	 msg=(TM_RTC_Time_t*)osMemoryPoolAlloc(CLOCK_memPool,osWaitForever);	//Alokujem pamat pre odosielanu spravu ...
	 if(msg != NULL) memcpy(msg,&datatime,sizeof(TM_RTC_Time_t));				//Pridelilo mi pamat ?, ak ano tak kopirujem data na odoslanie ...
	 status=osMessageQueuePut(CLOCK_msgQueue,&msg,0U,osWaitForever);	//Odosielam spravu na msgQueue ...
	 while(status != osOK) Error_Signal();																						//Bolo to OK, alebo chyba ...
	 //Send Message to queue ....
	 osDelay(OneSecond);
	}	
}

TM_DS1307_Time_t time;	//datatime

__NO_RETURN void rtc1307_i2cx_app(void *argument) 
{
	(void)argument;
	uint8_t rslt,Count=0x00;
	do
	 {
		switch(Count)
		{
			default							:	osMutexAcquire(mutex_i2c_id,osWaitForever);
														rslt=TM_DS1307_Init();											//I2C1, TM_I2C_PinsPack_1 rovnako ako u tasku rtc_app
														//rslt=TM_I2C_IsDeviceConnected(I2C1,DS1307_I2C_ADDR);						//rslt=connected=0x01;
														osMutexRelease(mutex_i2c_id);
														Count++;
														break;
			case Number_Retries	: Count=Number_Retries;
														break;
		}
		osDelay(OneSecond);
	 }
	while(rslt!=TM_DS1307_Result_Ok);
	/* Disable output first */
	TM_DS1307_DisableOutputPin();
	/* Set output pin to 1 - 4096 Hz */
	TM_DS1307_EnableOutputPin(TM_DS1307_OutputFrequency_1Hz);
	for(;;)
	{
		osDelay(OneSecond);
		/* Set date and time */
		time.hours = datatime.hours;
		time.minutes = datatime.minutes;
		time.seconds = datatime.seconds;
		time.date = datatime.date;
		time.day = datatime.day;
		time.month = datatime.month;
		time.year = datatime.year;
		osMutexAcquire(mutex_i2c_id,osWaitForever);		
		TM_DS1307_SetDateTime(&time);
		/* Get date and time */
		TM_DS1307_GetDateTime(&time);
		osMutexRelease(mutex_i2c_id);
	}
}

#ifdef SENSORTECH_BOSCH

extern int32_t bmp180_data_readout_template(void);

#define BMP180_IS_CONNECTED	(uint8_t)0x01

__NO_RETURN void bmp180_i2cx_app(void *argument)							//Uz funguje dobre simulacia ale nie je urobene citanie z BMP180 cez BMP180 API Call ...
{
	(void)argument;
	uint8_t rslt=BMP180_IS_CONNECTED;
	osStatus_t status;
	uint8_t Count=0x00;
	struct dht_device bmp180;
	DHT_msg_t *msg;																												//Kvoli MessageQueue pre BME280 .... a potom ide aj s optimalizaciou -O3 !!!uint8_t rslt=TM_BMP180_Result_Ok,Count=0x00;
  BMP180_msgQueue=osMessageQueueNew(DHT_POOL_OBJECTS,sizeof(DHT_msg_t*),NULL);	// Message queue used to pass pointers to msg_t
  BMP180_memPool=osMemoryPoolNew(DHT_POOL_OBJECTS,sizeof(DHT_msg_t),NULL);			// Memory pool for actual message objects
	do
	 {
		osDelay(TwoSecond);
		switch(Count)																							//Zopakujem 3x hladanie zariadenia na I2C
		{
			default						:		osMutexAcquire(mutex_i2c_id,osWaitForever);											
														//rslt=TM_BMP180_Init(&BMP180_Data);															//Pozri na adresu BMP180, je tam 0xEE>>1
														rslt=TM_I2C_IsDeviceConnected(I2C1,BMP180_I2C_ADDRESS);						//rslt=connected=0x01;
														osMutexRelease(mutex_i2c_id);
														Count++;
														break;
			case Number_Retries	:	Count=Number_Retries;
														break;
		}
	 }
	while(rslt!=BMP180_IS_CONNECTED);
	bmp180_data_readout_template();														//Inicializujem BMP180 !
	for(;;)
	{
		osDelay(TwoSecond);
		osMutexAcquire(mutex_i2c_id,osWaitForever);
		bmp180.dht.Type=Celsius;
		bmp180.dht.humidity=50.0;
		bmp180.dht.pressure=(float32_t)bmp180_get_uncomp_pressure();				//Skontroluj typy premennych uint32_t, ale je to OK a je float
		bmp180.dht.temperature=(float32_t)bmp180_get_uncomp_temperature();	//Skontroluj typy premennych uint16_t, ale je to OK a je float
		bmp180.read=(dht_exe_fptr_t)&DHT_Compute_Propiertys;																																//Jedno s tych ma byt ...
		bmp180_read((void*)&bmp180);																																							
		osMutexRelease(mutex_i2c_id);
		//Send Message to queue ....
		msg=(DHT_msg_t*)osMemoryPoolAlloc(BMP180_memPool,osWaitForever);	//Alokujem pamat pre odosielanu spravu ...
		if(msg != NULL) memcpy(msg,&bmp180.dht,sizeof(DHT_msg_t));				//Pridelilo mi pamat ?, ak ano tak kopirujem data na odoslanie ...
		status=osMessageQueuePut(BMP180_msgQueue,&msg,0U,osWaitForever);	//Odosielam spravu na msgQueue ...
		while(status != osOK) Error_Signal();														//Bolo to OK, alebo chyba ...
		//Send Message to queue ....		
	}
}

#else

TM_BMP180_t BMP180_Data;		//For BMP180

__NO_RETURN void bmp180_i2cx_app(void *argument) 
{
	(void)argument;
	osStatus_t status;
	uint8_t rslt;
	uint8_t Count=0x00;
	struct dht_device bmp180;
	DHT_msg_t *msg;																												//Kvoli MessageQueue pre BME280 .... a potom ide aj s optimalizaciou -O3 !!!uint8_t rslt=TM_BMP180_Result_Ok,Count=0x00;
  BMP180_msgQueue=osMessageQueueNew(BMP_POOL_OBJECTS,sizeof(DHT_msg_t*),NULL);	// Message queue used to pass pointers to msg_t
  BMP180_memPool=osMemoryPoolNew(BMP_POOL_OBJECTS,sizeof(DHT_msg_t),NULL);			// Memory pool for actual message objects
/*
	DHT_msg_t BMP180;
	//extern const DHT_msg_t DHT_Init;
	struct dht_device bmp180;
*/	
	do
	 {
		osDelay(TwoSecond);
		switch(Count)																							//Zopakujem 3x hladanie zariadenia na I2C
		{
			default						:		osMutexAcquire(mutex_i2c_id,osWaitForever);											
														rslt=TM_BMP180_Init(&BMP180_Data);
														//rslt=TM_I2C_IsDeviceConnected(I2C1,BMP180_I2C_ADDRESS);						//rslt=connected=0x01;
														osMutexRelease(mutex_i2c_id);
														Count++;
														break;
			case Number_Retries	:	Count=Number_Retries;
														break;
		}
	 }
	while(rslt!=TM_BMP180_Result_Ok);
	for(;;)
	{
		osDelay(OneSecond);

		osMutexAcquire(mutex_i2c_id,osWaitForever);
		TM_BMP180_StartTemperature(&BMP180_Data);		//Start temperature conversion
		osMutexRelease(mutex_i2c_id);
		osDelay(BMP180_Data.Delay/1000);
		osMutexAcquire(mutex_i2c_id,osWaitForever);
		TM_BMP180_ReadTemperature(&BMP180_Data);
		TM_BMP180_StartPressure(&BMP180_Data,TM_BMP180_Oversampling_UltraHighResolution);
		osMutexRelease(mutex_i2c_id);
		osDelay(BMP180_Data.Delay/1000);
		osMutexAcquire(mutex_i2c_id,osWaitForever);
		TM_BMP180_ReadPressure(&BMP180_Data);
		//printf("Temp: %2.3f degrees\nPressure: %6d Pascals\nAltitude at current pressure: %3.2f meters\n\n",BMP180_Data.Temperature,BMP180_Data.Pressure,BMP180_Data.Altitude);	//Format data and print to USART
		osMutexRelease(mutex_i2c_id);
		
		bmp180.dht.Type=Celsius;
		bmp180.dht.humidity=50.0;
		bmp180.dht.temperature=BMP180_Data.Temperature;
		bmp180.dht.pressure=BMP180_Data.Pressure;
		bmp180.read=(dht_exe_fptr_t)&DHT_Compute_Propiertys;
		bmp180_read(&bmp180);
		
		//Send Message to queue ....
		msg=(DHT_msg_t*)osMemoryPoolAlloc(BMP180_memPool,osWaitForever);	//Alokujem pamat pre odosielanu spravu ...
		if(msg != NULL) memcpy(msg,&bmp180.dht,sizeof(DHT_msg_t));				//Pridelilo mi pamat ?, ak ano tak kopirujem data na odoslanie ...
		status=osMessageQueuePut(BMP180_msgQueue,&msg,0U,osWaitForever);	//Odosielam spravu na msgQueue ...
		while(status != osOK) Error_Signal();														//Bolo to OK, alebo chyba ...
		//Send Message to queue ....		
		//DHT_Compute_Propiertys(&BMP180,BMP180_Data.Temperature,DHT11_Humidity);		//Tymto naplnim len strukturu BMP180 a o sebe nevedia ...
	}
}

#endif

__NO_RETURN void bmp280_i2cx_app(void *argument) 
{
	(void)argument;
	int8_t rslt = BMP280_OK;
	uint8_t Count=0x00;
	struct bmp280_dev bmp;
	struct bmp280_config conf;
	struct bmp280_uncomp_data ucomp_data;
	//int32_t temp32;
	//uint32_t pres32,pres64;	
	double_t temp,pres;	
  /* Assign device I2C address based on the status of SDO pin (GND for PRIMARY(0x76) & VDD for SECONDARY(0x77)) */
  //bmp.dev_id=BMP280_I2C_ADDR_PRIM;
	bmp.dev_id=BMP280_I2C_ADDR_SEC;
  /* Map the delay function pointer with the function responsible for implementing the delay */
  bmp.delay_ms=delay_ms;
  /* Select the interface mode as I2C */
  bmp.intf=BMP280_I2C_INTF;
  /* Map the I2C read & write function pointer with the functions responsible for I2C bus transfer */
  bmp.read=i2c_reg_read;
  bmp.write=i2c_reg_write;
	do
	 {
		osDelay(TwoSecond);
		switch(Count)																							//Zopakujem 3x hladanie zariadenia na I2C
		{
			default							:	osMutexAcquire(mutex_i2c_id,osWaitForever);
														//rslt=TM_I2C_IsDeviceConnected(I2C1,bmp.dev_id);						//rslt=connected=0x01;
														rslt=bmp280_init(&bmp);
														osMutexRelease(mutex_i2c_id);
														Count++;
														break;
			case Number_Retries	:	Count=Number_Retries;
														rslt=BMP280_E_DEV_NOT_FOUND;
														break;
		}
	 }
	while(rslt==BMP280_E_DEV_NOT_FOUND);
	osMutexAcquire(mutex_i2c_id,osWaitForever);
	rslt=bmp280_get_config(&conf,&bmp);
  /* Configuring the temperature oversampling, filter coefficient and output data rate */
  /* Overwrite the desired settings */
  conf.filter=BMP280_FILTER_COEFF_2;
  /* Temperature oversampling set at 4x */
  conf.os_temp=BMP280_OS_4X;
  /* Pressure oversampling set at 4x */
  conf.os_pres = BMP280_OS_4X; 
  /* Setting the output data rate as 1HZ(1000ms) */
  conf.odr=BMP280_ODR_1000_MS;
  rslt=bmp280_set_config(&conf,&bmp);
  /* Always set the power mode after setting the configuration */
  rslt=bmp280_set_power_mode(BMP280_NORMAL_MODE,&bmp);
	osMutexRelease(mutex_i2c_id);
	for(;;)
	{
	 osDelay(TwoSecond);																										//Sleep time between measurements=TwoSecond
	 osMutexAcquire(mutex_i2c_id,osWaitForever);														//Reading the raw data from sensor
   rslt=bmp280_get_uncomp_data(&ucomp_data,&bmp);													//Getting the 32 bit compensated temperature
   //rslt=bmp280_get_comp_temp_32bit(&temp32,ucomp_data.uncomp_temp,&bmp);	//Getting the compensated temperature as floating point value
   rslt=bmp280_get_comp_temp_double(&temp,ucomp_data.uncomp_temp,&bmp);		//Getting the compensated temperature as double_t point value
   //rslt=bmp280_get_comp_pres_32bit(&pres32,ucomp_data.uncomp_press,&bmp);	//Getting the compensated pressure using 32 bit precision
	 //rslt=bmp280_get_comp_pres_64bit(&pres64,ucomp_data.uncomp_press,&bmp);	//Getting the compensated pressure using 64 bit precision
	 rslt=bmp280_get_comp_pres_double(&pres,ucomp_data.uncomp_press,&bmp); 	//Getting the compensated pressure as floating point value
	 osMutexRelease(mutex_i2c_id);
	}
}

__NO_RETURN void bme280_i2cx_app(void *argument) 
{
	(void)argument;
	int8_t rslt = BME280_OK;
	uint8_t settings_sel,Count=0x00;
	DHT_msg_t *msg;																												//Kvoli MessageQueue pre BME280 .... a potom ide aj s optimalizaciou -O3 !!!	
	osStatus_t status;
	struct dht_device bme280;
	struct bme280_dev bmp;	
  struct bme280_data comp_data;
  BME280_msgQueue=osMessageQueueNew(BME_POOL_OBJECTS,sizeof(DHT_msg_t*),NULL);	// Message queue used to pass pointers to msg_t
  BME280_memPool=osMemoryPoolNew(BME_POOL_OBJECTS,sizeof(DHT_msg_t),NULL);			// Memory pool for actual message objects
  BME28x_msgQueue=osMessageQueueNew(BME_POOL_OBJECTS,sizeof(DHT_msg_t*),NULL);	// Message queue used to pass pointers to msg_t
  BME28x_memPool=osMemoryPoolNew(BME_POOL_OBJECTS,sizeof(DHT_msg_t),NULL);			// Memory pool for actual message objects
  BME28y_msgQueue=osMessageQueueNew(BME_POOL_OBJECTS,sizeof(DHT_msg_t*),NULL);	// Message queue used to pass pointers to msg_t
  BME28y_memPool=osMemoryPoolNew(BME_POOL_OBJECTS,sizeof(DHT_msg_t),NULL);			// Memory pool for actual message objects
	bmp.dev_id = BME280_I2C_ADDR_PRIM << 1;										//podla https://lastminuteengineers.com/bme280-arduino-tutorial/, ale podla datasheet-u sa v 8 bite posiela 7 bit, preto je to posunute o 1 bit vlavo t.j. 0x76<<1=0xEC !!!
	//bmp.dev_id=BME280_I2C_ADDR_SEC << 1;
	bmp.intf=BME280_I2C_INTF;
	bmp.read=i2c_reg_read;
	bmp.write=i2c_reg_write;
	bmp.delay_ms=delay_ms;
	do
	{
	 osDelay(TwoSecond);																													//bmp.delay_ms(TwoSecond);
	 switch(Count)																							
	 {
		 default							:	osMutexAcquire(mutex_i2c_id,osWaitForever);
														//rslt=TM_I2C_IsDeviceConnected(I2C1,bmp.dev_id);							//rslt=connected=0x01;
														rslt=bme280_init(&bmp);																			//rslt=BME280_OK = 0x00
														osMutexRelease(mutex_i2c_id);
														Count++;																										//Zopakujem 3x hladanie zariadenia na I2C
														break;
		 case	Number_Retries	:	Count=Number_Retries;																				
														rslt=BME280_E_DEV_NOT_FOUND;
														break;
	 }
	}
	while(rslt!=BME280_OK);
	/* Recommended mode of operation: Indoor navigation */
  bmp.settings.osr_h=BME280_OVERSAMPLING_1X;
  bmp.settings.osr_p=BME280_OVERSAMPLING_16X;
  bmp.settings.osr_t=BME280_OVERSAMPLING_2X;
  bmp.settings.filter=BME280_FILTER_COEFF_16;
	settings_sel=(BME280_OSR_PRESS_SEL | BME280_OSR_TEMP_SEL | BME280_OSR_HUM_SEL | BME280_FILTER_SEL);
	osMutexAcquire(mutex_i2c_id,osWaitForever);
	rslt=bme280_set_sensor_settings(settings_sel,&bmp);
	#ifdef FORCED_MODE
		rslt=bme280_set_sensor_mode(BME280_FORCED_MODE,&bmp);			//Dava lepsie vysledky, nemrzne s vysledkami !!!
	#else
		rslt=bme280_set_sensor_mode(BME280_NORMAL_MODE,&bmp);			//Mrzne s vysledkami !!!
	#endif
	//rslt=bme280_set_sensor_mode(BME280_SLEEP_MODE,&bmp);
	osMutexRelease(mutex_i2c_id);
	//Init routine ...
	memcpy(&bme280.dht,&DHT_Init,sizeof(DHT_msg_t));
	//Send Message to queue ....
	msg=(DHT_msg_t*)osMemoryPoolAlloc(BME280_memPool,osWaitForever);	//Alokujem pamat pre odosielanu spravu ...
	if(msg != NULL) memcpy(msg,&bme280.dht,sizeof(DHT_msg_t));				//Pridelilo mi pamat ?, ak ano tak kopirujem data na odoslanie ...
	status=osMessageQueuePut(BME280_msgQueue,&msg,0U,osWaitForever);	//Odosielam spravu na msgQueue ...
	while(status != osOK) Error_Signal();															//Bolo to OK, alebo chyba ...
	//Send Message to queue ....	
	for(;;)
	{
	 #ifdef FORCED_MODE
		 osDelay(TwoSecond-Delay_40ms);
		 osMutexAcquire(mutex_i2c_id,osWaitForever);
		 rslt=bme280_set_sensor_mode(BME280_FORCED_MODE,&bmp);
		 osMutexRelease(mutex_i2c_id);
		 osDelay(Delay_40ms);
		 osMutexAcquire(mutex_i2c_id,osWaitForever);
		 rslt=bme280_get_sensor_data(BME280_ALL,&comp_data,&bmp);		//Ide s akymkolvek K_TMO, nemrzne ...
		 osMutexRelease(mutex_i2c_id);
	 #else
		 osDelay(TwoSecond);
		 osMutexAcquire(mutex_i2c_id,osWaitForever);
		 rslt=bme280_get_sensor_data(BME280_ALL,&comp_data,&bmp);		//Najlepsie ide s K_TMO=150 do K_TMO=250, nemrzne ...
		 osMutexRelease(mutex_i2c_id);
	 #endif
	 bme280.dht.Type=Celsius;
	 bme280.dht.temperature=(float32_t)comp_data.temperature;
	 bme280.dht.humidity=(float32_t)comp_data.humidity;
	 bme280.dht.pressure=(uint32_t)comp_data.pressure;
	 bme280.read=(dht_exe_fptr_t)&DHT_Compute_Propiertys;
	 bme280_read((void*)&bme280);
	 //Send Message to queue ....
	 msg=(DHT_msg_t*)osMemoryPoolAlloc(BME280_memPool,osWaitForever);	//Alokujem pamat pre odosielanu spravu ...
	 if(msg != NULL) memcpy(msg,&bme280.dht,sizeof(DHT_msg_t));				//Pridelilo mi pamat ?, ak ano tak kopirujem data na odoslanie ...
	 status=osMessageQueuePut(BME280_msgQueue,&msg,0U,osWaitForever);	//Odosielam spravu na msgQueue ...
	 while(status != osOK) Error_Signal();														//Bolo to OK, alebo chyba ...
	 //Send Message to queue ....
	 msg=(DHT_msg_t*)osMemoryPoolAlloc(BME28x_memPool,osWaitForever);	//Alokujem pamat pre odosielanu spravu ...
	 if(msg != NULL) memcpy(msg,&bme280.dht,sizeof(DHT_msg_t));				//Pridelilo mi pamat ?, ak ano tak kopirujem data na odoslanie ...
	 status=osMessageQueuePut(BME28x_msgQueue,&msg,0U,osWaitForever);	//Odosielam spravu na msgQueue ...
	 while(status != osOK) Error_Signal();														//Bolo to OK, alebo chyba ...
	 //Send Message to queue ....
	 msg=(DHT_msg_t*)osMemoryPoolAlloc(BME28y_memPool,osWaitForever);	//Alokujem pamat pre odosielanu spravu ...
	 if(msg != NULL) memcpy(msg,&bme280.dht,sizeof(DHT_msg_t));				//Pridelilo mi pamat ?, ak ano tak kopirujem data na odoslanie ...
	 status=osMessageQueuePut(BME28y_msgQueue,&msg,0U,osWaitForever);	//Odosielam spravu na msgQueue ...
	 while(status != osOK) Error_Signal();														//Bolo to OK, alebo chyba ...
	}
}

#define Temperature_CompensationXXX

__NO_RETURN void ccs811_i2cx_app(void *argument) 
{
	(void)argument;
	#define CCS811_IS_CONNECTED (int8_t)0x01
	uint8_t Count=0x00;
	int8_t rslt=CCS811_IS_CONNECTED;
	DHT_msg_t BME28x,*BME28x_msg;															//Kvoli MessageQueue pre BME280 ....
	osStatus_t status;
	#ifdef Temperature_Compensation
		rslt_frac humidity,temperature;
	#endif
	ccs811_dev_t ccs811;
	ccs811_error ccs_error;
	ccs811_alg_results_t ccs_value,*msg;																										//CO2 carbon dioxide valid range from 400 to 8192 ppm and TVOC volatile organic carbon valid range from 0 to 1187 ppb
  CCS811_msgQueue=osMessageQueueNew(CCS_POOL_OBJECTS,sizeof(ccs811_alg_results_t*),NULL);	// Message queue used to pass pointers to ccs811_alg_results_t
  CCS811_memPool=osMemoryPoolNew(CCS_POOL_OBJECTS,sizeof(ccs811_alg_results_t),NULL);			// Memory pool for actual message objects
	ccs811.address=CCS811_DEFAULT_ADDRESS << 0x01;																					//0x5A,0x5B
	ccs811.read=(ccs811_func_ptr)i2c_reg_read;								
	ccs811.write=(ccs811_func_ptr)i2c_reg_write;
	//Init routine ...
	memcpy(&ccs_value,&ccs811_init_value,sizeof(ccs811_alg_results_t));
	//Send Message to queue ....
	msg=(ccs811_alg_results_t*)osMemoryPoolAlloc(CCS811_memPool,osWaitForever);	//Alokujem pamat pre odosielanu spravu ...
	if(msg != NULL) memcpy(msg,&ccs_value,sizeof(ccs811_alg_results_t));				//Pridelilo mi pamat ?, ak ano tak kopirujem data na odoslanie ...
	status=osMessageQueuePut(CCS811_msgQueue,&msg,0U,osWaitForever);						//Odosielam spravu na msgQueue ...
	while(status != osOK) Error_Signal();																				//Bolo to OK, alebo chyba ...
	//Send Message to queue ....
	do
	{	
		osDelay(TwoSecond);
		switch(Count)
		{
			 default							:	osMutexAcquire(mutex_i2c_id,osWaitForever);
															rslt=TM_I2C_IsDeviceConnected(I2C1,ccs811.address);	//rslt=connected=0x01;
															osMutexRelease(mutex_i2c_id);
															Count++;
															break;
			 case	Number_Retries	:	Count=Number_Retries;
															rslt=CCS811_E_DEV_NOT_FOUND;
															break;
		}
	}
	while(rslt!=CCS811_IS_CONNECTED);																			//while(rslt==CCS811_E_DEV_NOT_FOUND);
	
	do
	{
		osMutexAcquire(mutex_i2c_id,osWaitForever);
		ccs_error=ccs811_init(&ccs811);
		osMutexRelease(mutex_i2c_id);
		osDelay(5*Delay_20ms);
	}
	while(ccs_error!=CCS811_NO_ERRORS_FOUND);														//!!!!!!!!!!!!!!!!!!!!!
	
	for(;;)
	{
		//Receive Message from queue ....
		status=osMessageQueueGet(BME28x_msgQueue,&BME28x_msg,NULL,osWaitForever);		//Mam prijatu spravu v Queue ???
		if((status == osOK) && (BME28x_msg != NULL)) 
		 {
			memcpy((DHT_msg_t*)&BME28x,BME28x_msg,sizeof(DHT_msg_t));									//Kopirujem obsah message do DHT-BME struktury ...
			status=osMemoryPoolFree(BME28x_memPool,BME28x_msg);
		 }	 
		//Receive Message from queue ....
		osMutexAcquire(mutex_i2c_id,osWaitForever);
		#ifdef Temperature_Compensation
			humidity=Fraction(BME28x.humidity);
			temperature=Fraction(BME28x.temperature);
			ccs_error=ccs811_write_env_data(&ccs811,humidity.int_part,humidity.frc_part,temperature.int_part-25,temperature.frc_part);								//Compensation ...
			//osDelay(Delay_20ms);
		#endif
		ccs_value=ccs811_get_data(&ccs811);																					//Measurement in MODE 1, at constant power ...
		osMutexRelease(mutex_i2c_id);
		//Send Message to queue ....
		msg=(ccs811_alg_results_t*)osMemoryPoolAlloc(CCS811_memPool,osWaitForever);	//Alokujem pamat pre odosielanu spravu ...
		if(msg != NULL) memcpy(msg,&ccs_value,sizeof(ccs811_alg_results_t));				//Pridelilo mi pamat ?, ak ano tak kopirujem data na odoslanie ...
		status=osMessageQueuePut(CCS811_msgQueue,&msg,0U,osWaitForever);						//Odosielam spravu na msgQueue ...
		while(status != osOK) Error_Signal();																				//Bolo to OK, alebo chyba ...
		//Send Message to queue ....		
	}
}

__NO_RETURN void ssd1306_i2cx_app(void *argument) 
{
	(void)argument;
	#define TFT_CHARS	(uint8_t)18
	uint8_t rslt,Count=0x00;
	osStatus_t status;
	DHT_msg_t BME28y,*BME28y_msg;															//Kvoli MessageQueue pre BME280 ....
	char Retazec[SizeOfBuffer];
	do 
	 {
		switch(Count)
		{
			default							:	osMutexAcquire(mutex_i2c_id,osWaitForever);
														/* Init SSD1306 LCD 128 x 64 px */ 
														rslt=TM_SSD1306_Init();
														osMutexRelease(mutex_i2c_id);
														Count++;
														break;
			case Number_Retries	:	Count=Number_Retries;
														break;
		}
		osDelay(OneSecond);
	 }
	while(!rslt);
	//memcpy(&BMP180,&DHT_Init,sizeof(DHT_Init));											//Inicializujem BMP180 stukturu z tabulky, ale tu by to nemuselo byt ....
	osMutexAcquire(mutex_i2c_id,osWaitForever);
	TM_SSD1306_Fill(SSD1306_COLOR_BLACK);
	TM_SSD1306_UpdateScreen();
	TM_SSD1306_GotoXY(25,10);	
	//TM_SSD1306_Puts("PID-s",&TM_Font_16x26,SSD1306_COLOR_WHITE);
	TM_SSD1306_Puts("ARM-s",&TM_Font_16x26,SSD1306_COLOR_WHITE);
	TM_SSD1306_GotoXY(10,40);	
	TM_SSD1306_Puts("Regulators",&TM_Font_11x18,SSD1306_COLOR_WHITE);
	TM_SSD1306_UpdateScreen();
	osMutexRelease(mutex_i2c_id);
	osDelay(TwoSecond);
	osMutexAcquire(mutex_i2c_id,osWaitForever);
	TM_SSD1306_GotoXY(25,10);	
	TM_SSD1306_Puts("PID-s",&TM_Font_16x26,SSD1306_COLOR_WHITE);
	//TM_SSD1306_Puts("ARM-s",&TM_Font_16x26,SSD1306_COLOR_WHITE);
	TM_SSD1306_UpdateScreen();
	osMutexRelease(mutex_i2c_id);
	osDelay(TwoSecond);
	osMutexAcquire(mutex_i2c_id,osWaitForever);
	TM_SSD1306_Fill(SSD1306_COLOR_BLACK);
	TM_SSD1306_UpdateScreen();
	osMutexRelease(mutex_i2c_id);
	for(;;)
	{
		//Receive Message from queue ....
		status=osMessageQueueGet(BME28y_msgQueue,&BME28y_msg,NULL,osWaitForever);	//Mam prijatu spravu v Queue ???
		if((status == osOK) && (BME28y_msg != NULL)) 
		 {
			memcpy((DHT_msg_t*)&BME28y,BME28y_msg,sizeof(DHT_msg_t));				//Kopirujem obsah message do DHT-BME struktury ...
			status=osMemoryPoolFree(BME28y_memPool,BME28y_msg);
		 }	 
		//Receive Message from queue ....
		
		osMutexAcquire(mutex_i2c_id,osWaitForever);	
		/* Go to location X = 0, Y = 0 */
		TM_SSD1306_GotoXY(0,0);	
		snprintf(Retazec,TFT_CHARS,"%02d:%02d:%02d %02d.%02d.%2d",datatime.hours,datatime.minutes,datatime.seconds,datatime.date,datatime.month,datatime.year);
		TM_SSD1306_Puts(Retazec,&TM_Font_7x10,SSD1306_COLOR_WHITE);
		
		TM_SSD1306_GotoXY(0,10);	
		//TM_SSD1306_Puts("PID with STM32F407",&TM_Font_7x10,SSD1306_COLOR_WHITE);
		//sprintf(Retazec,"Teplota=%2.3f'C",bmp180.dht.temperature);
		//snprintf(Retazec,TFT_CHARS,"Teplota=%2.3f'C",(float32_t)bme280.dht.temperature);
		snprintf(Retazec,TFT_CHARS,"Teplota=%2.3f'C",(float32_t)BME28y.temperature);
		TM_SSD1306_Puts(Retazec,&TM_Font_7x10,SSD1306_COLOR_WHITE);
		
		//DHT_Compute_Propiertys(&BMP180,BMP180_Data.Temperature,DHT11_Humidity);
		//sprintf(Retazec,"Vlhkost=%2.0f%% PER:%1d",DHT11_Humidity,BMP180.Perception);
		//sprintf(Retazec,"Vlhkost=%2.0f%% PER:%1d",bmp180.dht.humidity,bmp180.dht.Perception);
		//snprintf(Retazec,TFT_CHARS,"Vlhkost=%2.0f%% PER:%1d",(float32_t)bme280.dht.humidity,bme280.dht.Perception);
		snprintf(Retazec,TFT_CHARS,"Vlhkost=%2.0f%% PER:%1d",(float32_t)BME28y.humidity,BME28y.Perception);
		TM_SSD1306_GotoXY(0,20);
		TM_SSD1306_Puts(Retazec,&TM_Font_7x10,SSD1306_COLOR_WHITE);

		//sprintf(Retazec,"HeatIndex=%2.2f'C",bmp180.dht.HeatIndex);
		//snprintf(Retazec,TFT_CHARS,"HeatIndex=%2.2f'C",(float32_t)bme280.dht.HeatIndex);
		snprintf(Retazec,TFT_CHARS,"HeatIndex=%2.2f'C",(float32_t)BME28y.HeatIndex);
		TM_SSD1306_GotoXY(0,30);
		TM_SSD1306_Puts(Retazec,&TM_Font_7x10,SSD1306_COLOR_WHITE);
		
		/* Go to location X = 20,Y = 25 */
		//TM_SSD1306_GotoXY(8,25);
		TM_SSD1306_GotoXY(0,40);
		//TM_SSD1306_Puts("I2C SSD1306 LCD",&TM_Font_7x10,SSD1306_COLOR_WHITE);
		//sprintf(Retazec,"Tlak=%2.3fhPa",(float32_t)BMP180_Data.Pressure/100);
		//snprintf(Retazec,TFT_CHARS,"Tlak=%4.4fhPa",(float32_t)(bme280.dht.pressure/100));
		snprintf(Retazec,TFT_CHARS,"Pressure=%4.2fhPa",(float32_t)(BME28y.pressure/100));
		TM_SSD1306_Puts(Retazec,&TM_Font_7x10,SSD1306_COLOR_WHITE);
		/* Go to location X = 15,Y = 45 */
		
		TM_SSD1306_GotoXY(0,50);
		//TM_SSD1306_Puts("Ing. Eduard Jadron",&TM_Font_7x10,SSD1306_COLOR_WHITE);
		//sprintf(Retazec,"Nad morom=%3.2fm",BMP180_Data.Altitude);
		//snprintf(Retazec,TFT_CHARS,"Nad morom=%4.2fm",(float32_t)bme280.dht.Altitude);
		snprintf(Retazec,TFT_CHARS,"Altitude=%4.3fm",(float32_t)BME28y.Altitude);
		TM_SSD1306_Puts(Retazec,&TM_Font_7x10,SSD1306_COLOR_WHITE);
		//TM_SSD1306_DrawLine(0,63,127,63,SSD1306_COLOR_WHITE);
		/* Invert pixels */
		//TM_SSD1306_ToggleInvert();
		//TM_SSD1306_UpdateScreen();
		//osDelay(1);
		//TM_SSD1306_ToggleInvert();
		TM_SSD1306_UpdateScreen();
		/* Update screen,send changes to LCD */
		osMutexRelease(mutex_i2c_id);
		//printf("Temp: %2.3f degrees\nPressure: %6d Pascals\nAltitude at current pressure: %3.2f meters\n\n",BMP180_Data.Temperature,BMP180_Data.Pressure,BMP180_Data.Altitude);	//Format data and print to USART
	}	
}

__NO_RETURN void bat_stmx_app(void *argument) 
{
	(void)argument;
	/* Initialize ADC1 group */
	TM_ADC_InitADC(ADC1);
	/* Enable vbat channel */
	TM_ADC_EnableVbat();
	for(;;)
	{
	 osDelay(TwoSecond);
	 Vbat=TM_ADC_ReadVbat(ADC1);
	}
}

__NO_RETURN void led_stmx_app(void *argument) 
{
	(void)argument;
	#define time (uint32_t)5
	for(;;)
	{
	 switch((int32_t)osEventFlagsWait(led_id,LED_GREEN|LED_ORANGE,osFlagsWaitAny,osWaitForever))
	  {
		 case	LED_GREEN		:	TM_DISCO_SetLed(LED_GREEN,ON);
												osDelay(time);
												TM_DISCO_SetLed(LED_GREEN,OFF);
												osDelay(time);
												break;
		 case	LED_ORANGE	:	TM_DISCO_SetLed(LED_ORANGE,ON);
												osDelay(time);
												TM_DISCO_SetLed(LED_ORANGE,OFF);
												osDelay(time);
												break;
		 default					:	TM_DISCO_SetLed(LED_GREEN,ON);
												TM_DISCO_SetLed(LED_ORANGE,ON);
												//osEventFlagsClear(led_id,osEventFlagsGet(led_id));
												break;
		}	
	}
}

__NO_RETURN void rot_encx_app(void *argument) 
{
	(void)argument;
	/* Initialize Rotary encoder 1, pin A = PD0, pin B = PD1 */		//Pozor na PD0 je DS18B20 a na PD1 je namapovany a prevadzkovany DHT11 !!!
	//TM_RE_Init(&RE1_Data, GPIOD, GPIO_PIN_0, GPIOD, GPIO_PIN_1);	
	/* Initialize Rotary encoder 2, pin A = PD3, pin B = PD5 */
	TM_RE_Init(&RE2_Data, GPIOD, GPIO_PIN_3, GPIOD, GPIO_PIN_5);
	/* Set rotation mode for rotary 1 */
	//TM_RE_SetMode(&RE1_Data, TM_RE_Mode_One); 
	/* Set rotation mode for rotary 2 */
	//TM_RE_SetMode(&RE2_Data, TM_RE_Mode_Zero);
	TM_RE_SetMode(&RE2_Data, TM_RE_Mode_One);
	for(;;)
	{
		osDelay(K_TMO);
		/* Get new rotation */
		//TM_RE_Get(&RE1_Data);
		TM_RE_Get(&RE2_Data);
	}
}

/* How many sensors we are expecting on OneWire bus ? */

#define EXPECTING_SENSORS	(uint8_t)0x01

__NO_RETURN void one_wire_app(void *argument) 
{
	(void)argument;
	//char buf[100];
	uint8_t devices,i,j,count,alarm_count;
	uint8_t device[EXPECTING_SENSORS][8],alarm_device[EXPECTING_SENSORS][8];
	float32_t temps[EXPECTING_SENSORS];
	/* OneWire working structure */
	TM_OneWire_t OneWire1;	
	/* Initialize OneWire1 instance on pin PD0 */
	TM_OneWire_Init(&OneWire1,GPIOD,GPIO_Pin_0);
	/* Check for any device on 1-wire */
	count = 0;
	while(devices) 
	{
		osDelay(OneSecond);
		osMutexAcquire(mutex_one_id,osWaitForever);
		devices = TM_OneWire_First(&OneWire1);
		/* Increase count variable */
		count++;		
		/* Get full 8-bytes rom address */
		TM_OneWire_GetFullROM(&OneWire1, device[count - 1]);
		/* Check for new device */
		devices = TM_OneWire_Next(&OneWire1);
		osMutexRelease(mutex_one_id);
	}	
	/* If any devices on 1-wire */
	if (count > 0) 
	{
		//sprintf(buf, "Devices found on 1-wire instance: %d\n", count);
		//TM_USART_Puts(USART1, buf);
		/* Display 64bit rom code */
		for (j = 0; j < count; j++) 
		{
			for (i = 0; i < 8; i++) 
			{
				//sprintf(buf, "0x%02X ", device[j][i]);
				//TM_USART_Puts(USART1, buf);
			}
			//TM_USART_Puts(USART1, "\n");
		}
	} else {}
		/* Nothing on OneWire */	
	/* Go through all connected devices and set resolution to 12bits */
	osMutexRelease(mutex_one_id);
	for (i = 0; i < count; i++) 
	 {
		/* Set resolution to 12bits */
		TM_DS18B20_SetResolution(&OneWire1,device[i],TM_DS18B20_Resolution_12bits);
	 }
	osMutexRelease(mutex_one_id);
	
	osDelay(OneSecond);
	 
	for(;;)
	{
		osMutexRelease(mutex_one_id);
		devices = TM_OneWire_First(&OneWire1);
		/* Start temperature conversion on all devices on one bus */
		TM_DS18B20_StartAll(&OneWire1);
		
		/* Wait until all are done on one onewire port */
		while (!TM_DS18B20_AllDone(&OneWire1)) osDelay(OneSecond);
		
		/* Read temperature from each device separatelly */
		for (i = 0; i < count; i++) 
		{
			/* Read temperature from ROM address and store it to temps variable */
			if (TM_DS18B20_Read(&OneWire1, device[i], &temps[i])) 
			{
				/* Print temperature */
				//sprintf(buf, "Temp %d: %3.5f; \n", i, temps[i]);
				//TM_USART_Puts(USART1, buf);
			} else 
			{
				/* Reading error */
				//TM_USART_Puts(USART1, "Reading error;\n");
			}
		}
		/* Reset alarm count */
		alarm_count = 0;
		/* Check if any device has alarm flag set */
		while (TM_DS18B20_AlarmSearch(&OneWire1)) 
		 {
			/* Store ROM of device which has alarm flag set */
			TM_OneWire_GetFullROM(&OneWire1,alarm_device[alarm_count]);
			/* Increase count */
			alarm_count++;
		 }
		/* Format string and send over USART for debug */
		//sprintf(buf, "Devices with alarm: %d\n",alarm_count);
		//TM_USART_Puts(USART1, buf);
		/* Any device has alarm flag set? */
		if (alarm_count > 0) 
		 {
			/* Show rom of this devices */
			for (j = 0; j < alarm_count; j++) 
			 {
				//TM_USART_Puts(USART1, "Device with alarm: ");
				for (i = 0; i < 8; i++) 
				 {
					//sprintf(buf, "0x%02X ", alarm_device[j][i]);
					//TM_USART_Puts(USART1, buf);
				 }
				//TM_USART_Puts(USART1, "\n    ");
			 }
			//TM_USART_Puts(USART1, "ALARM devices recognized!\n\r");
		 }
		
		/* Print separator */
		//TM_USART_Puts(USART1, "----------\n");
		osMutexRelease(mutex_one_id);
		/* Some delay */
		osDelay(TwoSecond);
	}
}

__NO_RETURN void pwm_stmx_app(void *argument) 
{
	(void)argument;
	TM_PWM_TIM_t TIM4_Data;
	/* Set PWM to 1kHz frequency on timer TIM4 */
	/* 10 kHz = 0.1ms = 100us */
	TM_PWM_InitTimer(TIM4, &TIM4_Data, 10000);
	/* Initialize PWM on TIM4, Channel 1 and PinsPack 2 = PD12 */
	TM_PWM_InitChannel(&TIM4_Data, TM_PWM_Channel_1, TM_PWM_PinsPack_2);
	/* Initialize PWM on TIM4, Channel 2 and PinsPack 2 = PD13 */
	TM_PWM_InitChannel(&TIM4_Data, TM_PWM_Channel_2, TM_PWM_PinsPack_2);
	/* Initialize PWM on TIM4, Channel 3 and PinsPack 2 = PD14 */
	TM_PWM_InitChannel(&TIM4_Data, TM_PWM_Channel_3, TM_PWM_PinsPack_2);
	/* Initialize PWM on TIM4, Channel 4 and PinsPack 2 = PD15 */
	TM_PWM_InitChannel(&TIM4_Data, TM_PWM_Channel_4, TM_PWM_PinsPack_2);	
	for(;;)
	{
		osDelay(OneSecond);
		/* Set channel 1 value, 50% duty cycle */
		TM_PWM_SetChannel(&TIM4_Data, TM_PWM_Channel_1, TIM4_Data.Period / 2);
		/* Set channel 2 value, 33% duty cycle */
		TM_PWM_SetChannel(&TIM4_Data, TM_PWM_Channel_2, TIM4_Data.Period / 3);
		/* Set channel 3 value, 25% duty cycle */
		TM_PWM_SetChannelPercent(&TIM4_Data, TM_PWM_Channel_3, 25);
		/* Set channel 4 value, 5% duty cycle*/
		TM_PWM_SetChannelPercent(&TIM4_Data, TM_PWM_Channel_4, 5);		
	}
}

__NO_RETURN void wdt_stmx_app(void *argument) 
{
	(void)argument;
	//TM_WATCHDOG_Init(TM_WATCHDOG_Timeout_500ms);
	//TM_WATCHDOG_Init(TM_WATCHDOG_Timeout_1s);
	//TM_WATCHDOG_Init(TM_WATCHDOG_Timeout_2s);
	TM_WATCHDOG_Init(TM_WATCHDOG_Timeout_4s);
	DBGMCU->APB1FZ |= DBGMCU_IWDG_STOP; 																									//Disable watchdog when we are in debug mode
	for(;;)
	{
	 TM_WATCHDOG_Reset();																																	//Reset watchdog	
	 osDelay(5*K_TMO);																																		//Nesmie byt WDT reset uz nikde pouzity lebo sa to nahodne zasekavalo ...
	}
}

void Init_PID(void)
{
	//uint8_t Mem;
	uint16_t i;

	ptr_par[REGK0]=((pid_params*)&par[REGK0]);															//Nacitam adresu objektu a dosadim do premennej typu ukazovatel aby som mal kompatibilitu s predchadzajucim PID2 napisanym v jazyku C51 pre 80C552
	ptr_par[REGV0]=((pid_params*)&par[REGV0]);															//Nacitam adresu objektu a dosadim do premennej typu ukazovatel aby som mal kompatibilitu s predchadzajucim PID2 napisanym v jazyku C51 pre 80C552
	ptr_var[REGK0]=((var_params*)&var[REGK0]);															//Nacitam adresu objektu a dosadim do premennej typu ukazovatel aby som mal kompatibilitu s predchadzajucim PID2 napisanym v jazyku C51 pre 80C552	 
	ptr_var[REGV0]=((var_params*)&var[REGV0]);															//Nacitam adresu objektu a dosadim do premennej typu ukazovatel aby som mal kompatibilitu s predchadzajucim PID2 napisanym v jazyku C51 pre 80C552

	memset(ptr_par[REGK0],NULL,sizeof(pid_params));												//Pridelim dynamicku pamat pre struktury a inicializujem ju ...
	memset(ptr_par[REGV0],NULL,sizeof(pid_params));												//Pridelim dynamicku pamat pre struktury a inicializujem ju ...
	memset(ptr_var[REGK0],NULL,sizeof(var_params));												//Pridelim dynamicku pamat pre struktury a inicializujem ju ...
	memset(ptr_var[REGV0],NULL,sizeof(var_params));												//Pridelim dynamicku pamat pre struktury a inicializujem ju ...

	memcpy(ptr_par[REGK0],&pid[REGK0],sizeof(pid_params));									//Nacitaj factory hodnoty z pamati programu ...
	memcpy(ptr_par[REGV0],&pid[REGV0],sizeof(pid_params));									//Nacitaj factory hodnoty z pamati programu ...
	
	ptr_par[REGK0]->Metoda=ZIE;																						//Volba metody vypoctu konstant Kp, Ti, Td regulatora pomocou Ziegler-Nichols, Cohen-Coon, ITA Load ....
	ptr_par[REGV0]->Metoda=ZIE;
	 
	//NOR=0, PID=1, ALE=2, TAK=3, PSD=4, DSP=5, ARM=6
	ptr_par[REGK0]->pid_model=ARM;																					//Vyber konkretneho typu regulatora DSP-LPF, Allen Bradley-LPF, Takahashi bez filtracie D zlozky - LPF, PSD bez LPF, DSP -> PID s koprocesosom, PSD s koprocesosorm ...
	ptr_par[REGV0]->pid_model=ARM;																					//Vyber konkretneho typu regulatora DSP-LPF, Allen Bradley-LPF, Takahashi bez filtracie D zlozky - LPF, PSD bez LPF, DSP -> PID s koprocesosom, PSD s koprocesosorm ...

	switch(ptr_par[REGK0]->Metoda)
	 {
		default	:
		case	ZIE	:	Vypocet_PID_Konstant(ptr_par[REGK0],ZIE,PID_Type,+115.0,+14691.0,+0.000);	break;	//Vypocet nepotrebuje _Khlt a _Thlt co sa zistuje komplikovanejsie ...
		case	COH	:	Vypocet_PID_Konstant(ptr_par[REGK0],COH,PID_Type,+115.0,+14691.0,+1.689);	break;	//Vypocet potrebuje _Khlt a _Thlt regulovanej sustavy, zistenie je obtiaznejsie ...
		case	ITA	: Vypocet_PID_Konstant(ptr_par[REGK0],ITA,PID_Type,+115.0,+14691.0,+1.689);	break;	//Vypocet potrebuje _Khlt a _Thlt regulovanej sustavy, zistenie je obtiaznejsie ...
	 }
	switch(ptr_par[REGV0]->Metoda)
	 {
		default	:
		case	ZIE	:	Vypocet_PID_Konstant(ptr_par[REGV0],ZIE,PID_Type,+115.0,+14691.0,+0.000);	break;	//Vypocet nepotrebuje _Khlt a _Thlt co sa zistuje komplikovanejsie ...
		case	COH	:	Vypocet_PID_Konstant(ptr_par[REGV0],COH,PID_Type,+115.0,+14691.0,+1.689);	break;	//Vypocet potrebuje _Khlt a _Thlt regulovanej sustavy, zistenie je obtiaznejsie ...
		case	ITA	: Vypocet_PID_Konstant(ptr_par[REGV0],ITA,PID_Type,+115.0,+14691.0,+1.689);	break;	//Vypocet potrebuje _Khlt a _Thlt regulovanej sustavy, zistenie je obtiaznejsie ...
	 }
	 
	ptr_par[REGK0]->k_lpf=0.1*ptr_par[REGK0]->td;													//Musia sa naplnit aj ine parametre, lebo to nespravne funguje ...
	ptr_par[REGV0]->k_lpf=0.1*ptr_par[REGV0]->td;													//Musia sa naplnit aj ine parametre, lebo to nespravne funguje ...

	ptr_par[REGK0]->Soll=50.0;																							//Nacitam ziadanu hodnotu ...
	ptr_par[REGV0]->Soll=50.0;																							//Nacitam ziadanu hodnotu ...

	ptr_par[REGK0]->Ekviterm=6;																						//Nastavim vykurovaciu krivku, musi byt nastavena pred spustenim vsetkych ostatnych taskov, inac to nefunguje ...
	ptr_par[REGV0]->Ekviterm=6;																						//Nastavim vykurovaciu krivku, musi byt nastavena pred spustenim vsetkych ostatnych taskov, inac to nefunguje ...
	 
 	ptr_par[REGK0]->ts=(float32_t)(K_TMO/1000.0);															//Musia sa naplnit aj ine parametre, lebo to nespravne funguje ...
	ptr_par[REGV0]->ts=(float32_t)(K_TMO/1000.0);															//Musia sa naplnit aj ine parametre, lebo to nespravne funguje ...

	switch(ptr_par[REGK0]->pid_model)
	 {
		default		:
		case	PID	:	init_pid_k0(ptr_par[REGK0]);	break;
		case	ALE	:	init_ale_k0(ptr_par[REGK0]);	break;
		case	TAK	:	init_tak_k0(ptr_par[REGK0]);	break;
		case	PSD	:	init_psd_k0(ptr_par[REGK0]);	break;
		case	DSP	:	init_dsp_k0(ptr_par[REGK0]);	break;											//Kedze nema obmedzenu integracnu/sumacnu zlozku, moze po dostatocnom "naintegrovani" hodnot pomalsie reagovat na vystupe regulatora
		case	ARM	:	init_arm_k0(ptr_par[REGK0]);	break;											//Kedze nema obmedzenu integracnu/sumacnu zlozku, moze po dostatocnom "naintegrovani" hodnot pomalsie reagovat na vystupe regulatora
	 }
	switch(ptr_par[REGV0]->pid_model)
	 {
		default		:
		case	PID	:	init_pid_v0(ptr_par[REGV0]);	break;
		case	ALE	:	init_ale_v0(ptr_par[REGV0]);	break;
		case	TAK	:	init_tak_v0(ptr_par[REGV0]);	break;
		case	PSD	:	init_psd_v0(ptr_par[REGV0]);	break;
		case	DSP	:	init_dsp_v0(ptr_par[REGV0]);	break;											//Kedze nema obmedzenu integracnu/sumacnu zlozku, moze po dostatocnom "naintegrovani" hodnot pomalsie reagovat na vystupe regulatora
		case	ARM	:	init_arm_v0(ptr_par[REGV0]);	break;											//Kedze nema obmedzenu integracnu/sumacnu zlozku, moze po dostatocnom "naintegrovani" hodnot pomalsie reagovat na vystupe regulatora
	 }
	 
	for(i=0; i<(2*sizeof(pid_params)); i++)
	 {
	 //Mem=((uint8_t*)ptr_par[REGK0])[i];																	//Funguje OK !!!
	 //Mem=((uint8_t*)par)[i];																						//Zapisem do zalohovanej SRAM
	 TM_BKPSRAM_Write8(i,((uint8_t*)par)[i]);															//Funguje OK !!!
	}
	 
	memset(ptr_par[REGK0],NULL,sizeof(pid_params));												//Pridelim dynamicku pamat pre struktury a inicializujem ju ...
	memset(ptr_par[REGV0],NULL,sizeof(pid_params));												//Pridelim dynamicku pamat pre struktury a inicializujem ju ...
	 
	for(i=0; i<(2*sizeof(pid_params)); i++) 
	 {
	 //Mem=TM_BKPSRAM_Read8(i);																						//Precitam zo zalohovanej SRAM
	 //((uint8_t*)ptr_par[REGK0])[i]=Mem;																	//Funguje OK !!!
	 ((uint8_t*)par)[i]=TM_BKPSRAM_Read8(i);															//Funguje OK !!!
	 } 
}

//Pozor na PD0 je DS18B20 a na PD1 je namapovany a prevadzkovany DHT11 !!!
//Used ports on board STM32F407VET6 BLACK Edition PA0,PA1,PA2,PA3,PA4,PA5,PA6,PA7,PA8,PA9,PA10,(PB3-PB5),PB6-PB7,PC6-PC7,(PC8-PC12),PC14,PC15,PD0-PD1,PD3-PD5,PD11-PD15,PE3,PE4

int main(void) 
{
	osThreadId_t tid;
	
	/* Initialize system */
	SystemInit();
	
	// System Initialization
  SystemCoreClockUpdate();
	 
  osKernelInitialize();                 													// Initialize CMSIS-RTOS

/* Initialize delay */
	TM_DELAY_Init();
	
	/* Initialize Leds */
	// LED_GREEN pin PA7, LED_ORANGE pin PA6
	TM_DISCO_LedInit();

	/* Initialize button on board K0-> pin PE4 K1-> pin PE3 */
	TM_DISCO_ButtonInit();
	
	/* Initialize ADC1 on channel 0, this is pin PA0 */
	//TM_ADC_Init(ADC1,ADC_Channel_0);
	/* Initialize ADC1 on channel 1, this is pin PA1 */
	//TM_ADC_Init(ADC1,ADC_Channel_1);
	/* Initialize ADC1 on channel 2, this is pin PA2 */
	TM_ADC_Init(ADC1,ADC_Channel_2);
	/* Initialize ADC1 on channel 3, this is pin PA3 */

	TM_ADC_Init(ADC1,ADC_Channel_3);
	/* Initialize DAC channel 1,pin PA4 */
	//TM_DAC_Init(TM_DAC1);
	/* Initialize DAC channel 2,pin PA5 */
	//TM_DAC_Init(TM_DAC2);

	/* Initialize I2C1, SCL: PB6 and SDA: PB7 with max. 500kHz serial clock */
	TM_I2C_Init(I2C1, TM_I2C_PinsPack_1, I2C_PID_SPEED);		//pri niektorych LCD HD44780 s STM32F4xx nestiha viac ako 300kHz, ale ci je to vinou STM32F407, alebo I2C na LCD neviem ...

	/* Initialize USART1,TX: PA9, RX: PA10 */
	TM_USART_Init(USART1,TM_USART_PinsPack_1, 10*115200);
	
	/* Initialize USART6,TX = PC6, RX = PC7, 115200 bauds */
	TM_USART_Init(USART6,TM_USART_PinsPack_1, 10*115200);
	
	/* Add output function for USART6_Stream */
	TM_STDIO_SetOutputFunction(&USART6_Stream, USART6_Stream_OutputFunction);	
	/* Add input function for USART6_Stream */
	TM_STDIO_SetInputFunction(&USART6_Stream, USART6_Stream_InputFunction);
/*
		// Check data on USART6 stream
		if(fgets(str, 100, &USART6_Stream) != NULL) 
			{
			// Send data back
			
			// Send data to USART2 stream
			 fprintf(&USART6_Stream,(char*)str);
		  } 
*/		

	TM_BKPSRAM_Init();

	Init_PID();
	
	TM_I2C_Init(I2C1,TM_I2C_PinsPack_1,I2C_PID_SPEED);
	
	mutex_usart1_id=osMutexNew(&Thread_232_Mutex_attr);							// Create and Initialize a Mutex object.
  while(mutex_usart1_id == NULL) Error_Signal();									// Mutex object is not created
	mutex_usart6_id=osMutexNew(&Thread_236_Mutex_attr);							// Create and Initialize a Mutex object.
  while(mutex_usart6_id == NULL) Error_Signal();									// Mutex object is not created
	mutex_i2c_id=osMutexNew(&Thread_I2C_Mutex_attr);								// Create and Initialize a Mutex object.
	while(mutex_i2c_id == NULL) Error_Signal();											// Mutex object is not created
	mutex_spi_id=osMutexNew(&Thread_SPI_Mutex_attr);								// Create and Initialize a Mutex object.
	while(mutex_spi_id == NULL) Error_Signal();											// Mutex object is not created
	mutex_one_id=osMutexNew(&Thread_ONE_Mutex_attr);								// Create and Initialize a Mutex object.
	while(mutex_one_id == NULL) Error_Signal();											// Mutex object is not created
	
	clk_id=osEventFlagsNew(NULL);																		// The function osEventFlagsNew creates a new event flags object that is used to send events across threads and returns the pointer to the event flags object identifier or NULL in case of an error. It can be safely called before the RTOS is started (call to osKernelStart), but not before it is initialized (call to osKernelInitialize).
	sek_id=osEventFlagsNew(NULL);																		// The function osEventFlagsNew creates a new event flags object that is used to send events across threads and returns the pointer to the event flags object identifier or NULL in case of an error. It can be safely called before the RTOS is started (call to osKernelStart), but not before it is initialized (call to osKernelInitialize).
	led_id=osEventFlagsNew(NULL);																		// The function osEventFlagsNew creates a new event flags object that is used to send events across threads and returns the pointer to the event flags object identifier or NULL in case of an error. It can be safely called before the RTOS is started (call to osKernelStart), but not before it is initialized (call to osKernelInitialize).
	
#ifdef SIMUL
	tid=osThreadNew(ccs811_i2cx_app,NULL,NULL); 	while(tid==NULL) Error_Signal();   	    					// Create application main thread
	tid=osThreadNew(bme280_i2cx_app,NULL,NULL); 	while(tid==NULL) Error_Signal();    	    				// Create application main thread
	tid=osThreadNew(bmp280_i2cx_app,NULL,NULL);   while(tid==NULL) Error_Signal();  	    					// Create application main thread
	tid=osThreadNew(bmp180_i2cx_app,NULL,NULL);  	while(tid==NULL) Error_Signal();    							// Create application main thread
	tid=osThreadNew(dht_dht21_app,NULL,NULL);  	  while(tid==NULL) Error_Signal();  	    					// Create application main thread
	tid=osThreadNew(dht_dht11_app,NULL,NULL);  	  while(tid==NULL) Error_Signal();  	    					// Create application main thread
	tid=osThreadNew(rtc1307_i2cx_app,NULL,NULL);  while(tid==NULL) Error_Signal();	     						// Create application main thread
	
	tid=osThreadNew(pwm_stmx_app,NULL,NULL);  	  while(tid==NULL) Error_Signal();  								// Create application main thread
	tid=osThreadNew(one_wire_app,NULL,NULL);  	  while(tid==NULL) Error_Signal();  								// Create application main thread

	tid=osThreadNew(rot_encx_app,NULL,NULL);  	  while(tid==NULL) Error_Signal();  								// Create application main thread
	tid=osThreadNew(led_stmx_app,NULL,NULL);  	  while(tid==NULL) Error_Signal();  								// Create application main thread
	tid=osThreadNew(bat_stmx_app,NULL,NULL);  	  while(tid==NULL) Error_Signal();  								// Create application main thread
	tid=osThreadNew(ssd1306_i2cx_app,NULL,NULL);  while(tid==NULL) Error_Signal();	  							// Create application main thread

	tid=osThreadNew(rtc_stmx_app,NULL,NULL);  	  while(tid==NULL) Error_Signal();  								// Create application main thread
	tid=osThreadNew(lcd_clkx_app,NULL,NULL);  	  while(tid==NULL) Error_Signal();  	    					// Create application main thread
	tid=osThreadNew(clk_stmx_app,NULL,NULL);  	  while(tid==NULL) Error_Signal();  	    					// Create application main thread
	tid=osThreadNew(reg_v000_app,NULL,NULL);			while(tid==NULL) Error_Signal();									// Create application main thread
	tid=osThreadNew(reg_k000_app,NULL,NULL);			while(tid==NULL) Error_Signal();									// Create application main thread	
	tid=osThreadNew(wdt_stmx_app,NULL,NULL);  	  while(tid==NULL) Error_Signal();   								// Create application main thread
#else
	tid=osThreadNew(ccs811_i2cx_app,&param[18],&ccs811_i2cx_app_attr);	    while(tid==NULL) Error_Signal();	// Create application main thread
	tid=osThreadNew(bme280_i2cx_app,&param[17],&bme280_i2cx_app_attr);	    while(tid==NULL) Error_Signal();	// Create application main thread
	tid=osThreadNew(bmp280_i2cx_app,&param[16],&bmp280_i2cx_app_attr);	    while(tid==NULL) Error_Signal();	// Create application main thread
	tid=osThreadNew(bmp180_i2cx_app,&param[15],&bmp180_i2cx_app_attr);  	    while(tid==NULL) Error_Signal();	// Create application main thread
	tid=osThreadNew(dht_dht21_app,&param[14],&dht_dht21_app_attr);	    			while(tid==NULL) Error_Signal();	// Create application main thread
	tid=osThreadNew(dht_dht11_app,&param[13],&dht_dht11_app_attr);  	    		while(tid==NULL) Error_Signal();	// Create application main thread
	tid=osThreadNew(rtc1307_i2cx_app,&param[12],&rtc1307_i2cx_app_attr);    	while(tid==NULL) Error_Signal();	// Create application main thread

	tid=osThreadNew(pwm_stmx_app,&param[11],&pwm_stmx_app_attr);  	   				while(tid==NULL) Error_Signal();	// Create application main thread
	tid=osThreadNew(one_wire_app,&param[10],&one_wire_app_attr);    					while(tid==NULL) Error_Signal();	// Create application main thread
	
	tid=osThreadNew(rot_encx_app,&param[9],&rot_encx_app_attr);  	    			while(tid==NULL) Error_Signal();	// Create application main thread
	tid=osThreadNew(led_stmx_app,&param[8],&led_stmx_app_attr);  	    			while(tid==NULL) Error_Signal();	// Create application main thread
	tid=osThreadNew(bat_stmx_app,&param[7],&bat_stmx_app_attr);  	    			while(tid==NULL) Error_Signal();	// Create application main thread
	tid=osThreadNew(ssd1306_i2cx_app,&param[6],&ssd1306_i2cx_app_attr);  	  while(tid==NULL) Error_Signal();  // Create application main thread

	tid=osThreadNew(rtc_stmx_app,&param[5],&rtc_stmx_app_attr);  	    			while(tid==NULL) Error_Signal();	// Create application main thread
	tid=osThreadNew(lcd_clkx_app,&param[4],&lcd_clkx_app_attr);  	    			while(tid==NULL) Error_Signal();	// Create application main thread
	tid=osThreadNew(clk_stmx_app,&param[3],&clk_stmx_app_attr);  	    			while(tid==NULL) Error_Signal();	// Create application main thread
	tid=osThreadNew(reg_v000_app,&param[2],&reg_v000_app_attr);							while(tid==NULL) Error_Signal();	// Create application main thread
	tid=osThreadNew(reg_k000_app,&param[1],&reg_k000_app_attr);							while(tid==NULL) Error_Signal();	// Create application main thread	
	tid=osThreadNew(wdt_stmx_app,&param[0],&wdt_stmx_app_attr);    					while(tid==NULL) Error_Signal();	// Create application main thread
#endif

  osKernelStart();                      													// Start thread execution
	
  for(;;) {}
		
}

