#include <ESP8266WiFi.h>
#include "DHTesp.h"

// Wi-Fi Settings
const char* ssid = "CISCO"; // your wireless network name (SSID)
const char* password = "0123456789ABC"; // your Wi-Fi network password

WiFiClient client;
DHTesp dht;

// ThingSpeak Settings
const int channelID = xxxxxx;
String writeAPIKey = "xxxxxxxxxxxx"; // write API key for your ThingSpeak Channel
const char* server = "api.thingspeak.com";  //18.235.222.172
//const char* server = "18.235.222.172";
const int postingInterval = 5 * 60 * 1000; // post data every 5*60 seconds

void setup()
{
  String thisBoard= ARDUINO_BOARD;
  Serial.begin(115200);
  Serial.println(thisBoard);
  dht.setup(D4, DHTesp::DHT11); // Connect DHT sensor to D4
  WiFi.begin(ssid, password);
  while (WiFi.status() != WL_CONNECTED)
  {
    delay(500);
    Serial.print(".");
  }
  Serial.println("");
  Serial.println("WiFi connected");
  Serial.print("IP address: ");
  Serial.println(WiFi.localIP());
}

void loop() 
{
  //delay(dht.getMinimumSamplingPeriod());
  float humidity = dht.getHumidity();
  float temperature = dht.getTemperature(); 
  if (client.connect(server, 80))
  {
    // Measure Signal Strength (RSSI) of Wi-Fi connection
    float rssi = WiFi.RSSI();

    // Construct API request body
    String body = "&field1=";
           body += String(temperature);
           body += "&field2=";
           body += String(humidity);
           body += "&field3=";
           body += String(rssi);
    
    Serial.print("Teplota: ");
    Serial.println(temperature); 
    Serial.print("Vlhkost: ");
    Serial.println(humidity); 
    Serial.print("RSSI: ");
    Serial.println(rssi); 

    client.println("POST /update HTTP/1.1");
    client.println("Host: api.thingspeak.com");
    client.println("User-Agent: ESP8266 (nothans)/1.0");
    client.println("Connection: close");
    client.println("X-THINGSPEAKAPIKEY: " + writeAPIKey);
    client.println("Content-Type: application/x-www-form-urlencoded");
    client.println("Content-Length: " + String(body.length()));
    client.println("");
    client.print(body);

  }
  client.stop();
  // wait and then post again
  delay(postingInterval);
}
