#include "cmsis_os2.h"
#include "rtx_os.h"
#include "tm_stm32f4_delay.h"
#include "tm_stm32f4_disco.h"
#include <stdio.h>
#include <stdlib.h>
#include <defines.h>
#include <pidreg.h>
#include "arm_math.h"

int16_t Error[3];			//int16_t Error,dError,LastError;

#define SIZE	5		//Velkost inferencneho bloku !!!

int16_t FX1[SIZE],FX2[SIZE],Y[SIZE];

//typedef enum {NM,NS,ZE,PS,PM} State;

#define NM	0	// Negative medium
#define NS	1	// Negative small
#define ZE	2	// Zero equal
#define PS	3	// Positive small
#define PM	4	// Positive medium

const uint8_t InferencnaTabulka[SIZE][SIZE] =
{    /*NM,NS,ZE,PS,PM*///dError X2[i]
/*NM*/{PM,PM,PM,PS,ZE},//NM	 E
/*NS*/{PM,PM,PS,ZE,NS},//NS	 r
/*ZE*/{PM,PS,ZE,NS,NM},//ZE	 r
/*PS*/{PS,ZE,NS,NM,NM},//PS	 o
/*PM*/{ZE,NS,NM,NM,NM} //PM	 r
};				       			 //X1[i]

#define K 0x18
#define Max_Value	0x1000	//2^12=0x1000=4096 z ADC prevodnika ...

const int16_t VystupnaFunkcia[SIZE] = {-2*K,-K,+0x00,+K,+2*K};

typedef enum {SKY=+Max_Value,SK0=+0x0000,SK1=+Max_Value,SK2=+2*Max_Value} Osi;

void Fuzzyfikator(int16_t Value, int16_t *Data)		//Nema tu byt nahodou int32_t ukazovatel v pripade STM32F407VET6 ???
{
 uint8_t i;
 for(i=0x00; i<SIZE; i++) Data[i]=0x00;
 if(Value<-SK2) Data[NM]=SKY;
 else if(Value<-SK1)
 {
  Data[NM]=SKY-(Value+SK2);
  Data[NS]=Value+SK2;
 }
 else if(Value<+SK0)
 {
  Data[NS]=SKY-(Value+SK1);
  Data[ZE]=Value+SK1;
 }
 else if(Value<+SK1)
 {
  Data[ZE]=SKY-Value;
  Data[PS]=Value;
 }
 else if(Value<+SK2)
 {
  Data[PS]=SKY-(Value-SK1);
  Data[PM]=Value-SK1;
 }
 else Data[PM]=SKY;
}

void FuzzyInferencnyModul(int16_t *X1, int16_t *X2, int16_t *Y)
{
 int16_t min[SIZE];
 int16_t max,Temp;							//Tu musi byt v pripade RTX51 a LARGE modelu "data int16_t max" s optimalizaciou Loop rotation - 6
 uint8_t i,j,maxpos;
 for(i=0x00; i<SIZE; i++) Y[i]=0x00;	//Vymazem vystupny vektor Y[], je to neefektivnejsie ako memset()
 for(i=0x00; i<SIZE; i++)
  {
   for(j=0x00; j<SIZE; j++) if(X1[i]<X2[j]) min[j]=X1[i]; else min[j]=X2[j];
   max=min[0];
   maxpos=0x00;
   for(j=0x01; j<SIZE; j++) if(max<min[j]) {max=min[j]; maxpos=j;}
   Temp=Y[InferencnaTabulka[i][maxpos]];
   if(Temp<max) Y[InferencnaTabulka[i][maxpos]]+=max;
   if(Temp>SKY) Y[InferencnaTabulka[i][maxpos]]=SKY;
  }
}

int16_t Defuzzyfikator(int16_t *Y)
{
 uint8_t i;
 int16_t ReturnValue=0,SumY=0;   //COG algoritmus - Centrum Of Gravity
 for(i=0x00; i<SIZE; i++)
  {
   SumY+=Y[i];
   ReturnValue+=Y[i]*VystupnaFunkcia[i];
  }
 return((uint32_t)ReturnValue<<2)/SumY;	//Skalujem - nasobim cislom 4
}

void reg_fuz_k0(double_t xk, double_t *yk, pid_params *p, var_params *v)	//Treba skontrolovat ci je to dobre napisane ....
{
 int16_t ek;
 v->ek_2=ek;																					//Error[2]=Error[0];
 ek=p->Soll-xk;																				//Error[0]=(p->Soll-xk);
 v->ek_1=ek-v->ek_2;																	//Error[1]=(Error[0]-Error[2]);
 Fuzzyfikator(ek,FX1);																//Fuzzyfikator(Error[0],FX1);
 Fuzzyfikator((int16_t)v->ek_1,FX2);									//Fuzzyfikator(Error[1],FX2);
 FuzzyInferencnyModul(FX1,FX2,Y);
 *yk=(double)Defuzzyfikator(Y);
 if (*yk > GMA_HLIM)																	// limit y[k] to GMA_HLIM and GMA_LLIM
		{
		*yk = GMA_HLIM;
		}
	else 
			if (*yk < GMA_LLIM)
				{
					*yk = GMA_LLIM;
				}
}


